!=========================================================================
!  Copyright (C) GemTalk Systems 1986-2024.  All Rights Reserved.
! 
!  Used to support the java ZonedDateTime class.
!
!  File image/GbjZonedDateTime.gs
!
!=========================================================================

doit
DateAndTime subclass: 'GbjZonedDateTime'
  instVarNames: #()
  classVars: #( )
  classInstVars: #()
  poolDictionaries: #()
  inDictionary: Globals
%

doit
GbjZonedDateTime removeAllMethods.
GbjZonedDateTime class removeAllMethods.
%
set class GbjZonedDateTime
run
GbjZonedDateTime comment:
'GbjZonedDateTime is used by GBJ to represent instances of Java ZonedDateTime' .
^ true
%

category: 'testing'
classmethod: GbjZonedDateTime
checkEtcTimeZone
  | s f |
  f := GsFile openReadOnServer:'/etc/timezone'.
  f ifNotNil:[ | etc curr |
    s := f contents . f close.
    (s last == Character lf ) ifTrue:[ s size: (s size - 1) ].
    (etc := (TimeZone named: s)) = (curr := TimeZone current) ifFalse:[
      GsFile gciLogServer:'TimeZone current  : ' , curr asString .
      GsFile gciLogServer:'contents of /etc/timezone  : ' , s .
      GsFile gciLogServer:'TimeZone named: ', s printString,'  :  ', etc printString .
      Error signal:'TimeZone current  ', curr asString, '  does not agree with /etc/timezone  ', s .
    ].
    ^ true
  ] ifNil:[
    Error signal: 'Cannot open /etc/timezone  ', GsFile serverErrorString .
  ].
%

