/*=========================================================================
 * Copyright (C) GemTalk Systems 1986-2024.  All Rights Reserved.
 *
 *      BigDecimalFloat.java  
 *
 * Subclass of java BigDecimal to handle GS DecimalFloat objects
 *
 *========================================================================
 */

package com.gemstone.gbj;

import java.util.logging.*;
import com.gemstone.gbjgci.*;
import java.math.BigInteger;
import java.math.BigDecimal;

/**
Instances of this class represent GS DecimalFloat objects.
This is defined as a subclass of BigDecimal to tell them apart from
java BigDecimal / GS ScaledDecimal mappings.

 * @version 3.2
 */

public class BigDecimalFloat extends BigDecimal {

    /**
     * Generate a BigDecimalFloat from an unscaled value and its scale.
     * @param unscaledVal - unscaled value of the BigDecimalFloat
     * @param scale - scale of the BigDecimalFloat
     */
    public BigDecimalFloat(BigInteger unscaledVal, int scale) {
	super(unscaledVal, scale);
    }

    /**
     * Generate a BigDecimalFloat from a string.
     * @param str - String representation for the BigDecimalFloat
     */
    public BigDecimalFloat(String str) {
	super(str);
    }
}


