/*=========================================================================
 * Copyright (C) GemTalk Systems 1986-2024.  All Rights Reserved.
 *
 *      GbjAbortingException.java  
 *
 *========================================================================
 */

package com.gemstone.gbj;

import com.gemstone.gbjgci.*;


/**
 *  This class represents a GemStone server exception that forced a rollback of the
 *  current transaction.  These exceptions are not typically thrown during the course
 *  of a normal application and pertain more to server administration tasks, such
 *  as restoring the repository from backup.
 * 
 * 
 * @version 3.0
 */

 public class GbjAbortingException extends GbjException {

    /**
     * Creation method.
     * @param s The GbjSession triggering the error
     * @param e The GbjGciException associated with this error
     */
     //    protected GbjAbortingException(GbxInput input) {
     //        super(input);
     //    }

    public GbjAbortingException(GbjSession s, GbjGciException e) {
	super(s, e);
    }


 }

