/*=========================================================================
 * Copyright (C) GemTalk Systems 1986-2024.  All Rights Reserved.
 *
 *      GbjRuntimeException.java  
 *
 *========================================================================
 */

package com.gemstone.gbj;

import com.gemstone.gbjgci.*;


/**
 *  This class represents a GemStone server runtime exception, such as a key not being
 *  found in a dictionary, division by zero, message not understood, and so on.  The
 *  message of a GbjRuntimeException usually describes the particular exception well, and
 *  a stack trace will show the GemStone method where the error occurred.
 * 
 * 
 * @version 3.0
 */

 public class GbjRuntimeException extends GbjException {

    /**
     * internal method
     */
    protected GbjRuntimeException() {
    }

     ///**
     //* internal method
     //*/
     //    protected GbjRuntimeException(GbxInput input) {
     //        super(input);
     //    }

    public GbjRuntimeException(GbjSession s, GbjGciException e) {
	super(s, e);
    }



 }

