/*=========================================================================
 * Copyright (C) GemTalk Systems 1986-2024.  All Rights Reserved.
 *
 * $Id: GbxConstants.java $
 *
 * Created on May 1, 2002, 3:30 PM
 *
 * WARNING: MAKE CHANGES TO:
 *             GbxConstants.java.template
 *          NOT TO:
 *             GbxConstants.java 
 *             (which is generated from the template file)
 *
 *========================================================================
 */

package com.gemstone.gbj;


/**
 * Constants used internally by GBJ
 */
public final class GbxConstants {
    
    public static final String NOT_CONNECTED = "Not Connected";
    public static final String VERSION_STRING ="3.2.0";
    
    public static final String preClassDefinition = "NameOfSuperclass subclass: 'NameOfClass'\n" +
		 "\tinstVarNames: #(instVarName1 instVarName2)\n" +
		 "\tclassVars: #(ClassVarName1 ClassVarName2)\n" +
		 "\tclassInstVars: #(ClassInstVarName1 ClassInstVarName2)\n" +
		 "\tpoolDictionaries: #( )\n" +
		 "\tinDictionary: ";
	public static final String postClassDefinition = "\n" +
                 "\toptions: #( )";
        // 46464: for GS/S 32-bit
        public static final String postClassDefinition32 = "\n" +
                 "\tconstraints: #[]\n" +
                 "\tinstancesInvariant: false\n" +
	         "\tisModifiable: false";
	public static final String noDictionaryString = "There is no dictionary selected";
	public static final String noClassString = "There is no class selected";
	public static final String noProtocolString = "There is no protocol selected";
	public static final String noMethodString = "There is no method selected";
	public static final String methodString = "message selector and argument names\n" +
		"\t\"comment stating purpose of message\"\n" +
		"\n" +
		"\t| temporary variable names |\n" +
		"\tstatements\n";
	public static final String fileOutDictionaryString = "File out dictionary as...";
	public static final String fileOutClassString = "File out class as...";
	public static final String fileOutMethodString = "File out method as...";
	public static final String addDictionaryString = "Enter a dictionary name";
	public static final String renameDictionaryString = "Enter a new dictionary name";
	public static final String findClassString = "Enter a class name";
	public static final String addProtocolString = "Enter a protocol name";
	public static final String renameProtocolString = "Enter a new protocol name";
	public static final String moveMethodString = "Enter a destination protocol name";
	public static final String messagesString = "Find all implementors of...";
	public static final String moveClassString = "Move to dictionary...";
	public static final String instVarRefsString = "Browse references to inst var...";
	public static final String classVarRefsString = "Browse references to class var...";
	public static final String findMethodString = "Find method...";
	public static final String removeDictionaryString = "Are you sure you want to remove this dictionary?";
	public static final String removeClassString = "Are you sure you want to remove this class?";
	public static final String removeProtocolString = "Are you sure you want to remove all methods in this protocol?";
	public static final String removeMethodString = "Are you sure that you want to remove this method?";
	public static final String securityExceptionString = "*** Security Exception - file out is shown below ***";
   public  static final String noSessionString = "There is no current session";
	public static final String browseImplementorsString = "Browse implementors of...";
	public static final String browseSendersString = "Browse senders of...";
	public static final String browseReferencesString = "Browse references to...";
	public static final String substringSearchString = "Browse methods including substring...";
	public static final String fontNameString = "Choose a font for the tools";
	public static final String fontSizeString = "Choose a font size";
	public static final String browseClassString = "Browse class...";
	public static final String browseHierarchyString = "Browse hierarchy...";
	public static final String versionString = VERSION_STRING; 
   public static final String moveVersionString = "Enter name of the class to move this version to";
	public static final String migrateInstancesString = "Migrate instances to...";
   
    /** Creates new GbjConstants */
    public GbxConstants() {
    }
    
}
