/*=========================================================================
 * Copyright (C) GemTalk Systems 1986-2024.  All Rights Reserved.
 *
 *      GbjGciLogFormatter.java  
 *
 *========================================================================
 */

package com.gemstone.gbjgci;

import java.util.logging.Formatter;
import java.util.logging.LogRecord;
import java.util.logging.Level;

/**

GbjGciLogFormatter provides formatting for logging messages used within GBJ.

@version 3.1
*/

public class GbjGciLogFormatter extends Formatter {

    public String format(LogRecord record) {
	String prefix;
	Level level = record.getLevel();
	if (level == Level.SEVERE)       prefix = "[ERROR ] ";
	else if (level == Level.WARNING) prefix = "[ WARN ] ";
	else if (level == Level.INFO)    prefix = "[ INFO ] ";
	else if (level == Level.CONFIG)  prefix = "[CONFIG] ";
	else if (level == Level.FINE)    prefix = "[ FINE ] ";
	else if (level == Level.FINER)   prefix = "[FINER ] ";
	else if (level == Level.FINEST)  prefix = "[FINEST] ";
	else prefix = "[DEBUGX] ";

	return prefix + record.getMessage() + "\n";
    }

}

