/*
 * GbjBrowser.java
 *
 * Created on May 23, 2002, 4:44 PM
 */

package com.gemstone.tools;

import com.gemstone.gbj.*;
import javax.swing.*;
import java.awt.Container;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Dimension;
import javax.swing.border.*;
import java.awt.Font;
import java.awt.Cursor;
import java.util.Vector;
import java.awt.event.*;

import javax.swing.text.*;

/**
 *
 * @author vincef
 * @version 1.3
 */


public  class GbjBrowser extends com.gemstone.tools.GbxTool {
    
    protected JScrollPane sScroll;
    protected JList   symbolDictionaries;
    protected JScrollPane sDScroll;
    protected JList classes;
    protected JScrollPane cScroll;
    protected JList protocol;
    protected JScrollPane pScroll;
    protected JList methods;
    protected JScrollPane mScroll;
    protected ButtonGroup instOrClass;
    protected JRadioButton instanceRB;
    protected JRadioButton classRB;
    protected JMenu dictionaryMenu;
    protected JMenu classMenu;
    protected JMenu protocolMenu;
    protected JMenu methodMenu;
    protected int xSize;
    protected int ySize;
    protected JPanel buttonPanel;
    protected JPanel listPanel;
    protected JPopupMenu dictPopup;
    protected JPopupMenu classPopup;
    protected JPopupMenu protoPopup;
    protected JPopupMenu methodPopup;
    protected boolean template=false;
    
    boolean classInst = true;
    String textMode;
    static String LastProtocol = "";
    static String MethodMoveProtocol="";
    int browseLevel = -1;
    GbxClassHolder [] classList;
    GbxDictionaryHolder [] dictionaryList;
    GbxMethodHolder [] methodList;
    String [] protocolList;
    /**
     * @param session   GbjSession 
     * @param launcher  GbjLauncher */
    public GbjBrowser(GbjSession session, GbjLauncher launcher){
        this(session);
        this.launcher=launcher;
        launcher.registerWindow(this);
    }
    
    /**
     * @param session  GbjSession */
    public GbjBrowser(GbjSession session){
        this();
        this.session=session;
        initUI();
    }
    
    /** Creates new GbjBrowser */
    public GbjBrowser() {
        
    }
    
    public void openOnSession(){
        resetDictionaryList();
    }
    
    public void windowClosing(java.awt.event.WindowEvent windowEvent) {
        if (launcher != null) {
          launcher.deregisterWindow(this);
        }
    }
    
    private void resetDictionaryList(){
        this.dictionaryList_dictionary_classList_class_protocolList_protocol_methodList_method_(null, this.selectedDictionary(), null, this.selectedClass(), null, this.selectedProtocol(), null, this.selectedMethod());
    }
    
    protected void initUI(){
        setTitle("GBJ Browser");
        workspace=new JTextArea();
        createActionTable(workspace);
        makeActionPretty();
        super.initUI();
        workspace.addMouseListener(this);
        sScroll=new JScrollPane(workspace);
        sScroll.setPreferredSize(new Dimension(640,200));
        symbolDictionaries=new JList();
        symbolDictionaries.addMouseListener(this);
        symbolDictionaries.addListSelectionListener(this);
        symbolDictionaries.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        sDScroll=new JScrollPane();
        sDScroll.setViewportView(symbolDictionaries);
        sDScroll.setPreferredSize(new Dimension(150,100));
        classes=new JList();
        classes.addListSelectionListener(this);
        classes.addMouseListener(this);
        cScroll=new JScrollPane();
        cScroll.setViewportView(classes);
        cScroll.setPreferredSize(new Dimension(170,80));
        classes.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        protocol=new JList();
        protocol.addListSelectionListener(this);
        protocol.addMouseListener(this);
        protocol.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        pScroll=new JScrollPane();
        pScroll.setViewportView(protocol);
        pScroll.setPreferredSize(new Dimension(150,100));
        methods=new JList();
        methods.addMouseListener(this);
        methods.addListSelectionListener(this);
        methods.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        mScroll=new JScrollPane();
        mScroll.setViewportView(methods);
        mScroll.setPreferredSize(new Dimension(170,100));
        instOrClass=new ButtonGroup();
        instanceRB=new JRadioButton("Instance");
        classRB=new JRadioButton("Class");
        instOrClass.add(instanceRB);
        instOrClass.add(classRB);
        instanceRB.addActionListener(this);
        instanceRB.setActionCommand("Instance");
        classRB.addActionListener(this);
        classRB.setActionCommand("Class");
        instanceRB.setSelected(true);
        buttonPanel=new JPanel();
        listPanel=new JPanel();
        listPanel.setLayout(new BorderLayout());
        listPanel.add(cScroll,BorderLayout.CENTER);
        buttonPanel.add(instanceRB);
        buttonPanel.add(classRB);
        listPanel.add(buttonPanel,BorderLayout.SOUTH);
        content.setLayout(new BorderLayout());
        JSplitPane sPane1=new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,sDScroll,listPanel);
        sPane1.setDividerSize(4);
        sPane1.setDividerLocation(.50);
        sPane1.setResizeWeight(.50);
        JSplitPane sPane2=new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,pScroll,mScroll);
        sPane2.setDividerSize(4);
        sPane2.setDividerLocation(.50);
        sPane2.setResizeWeight(.50);
        JSplitPane sPane3=new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,sPane1,sPane2);
        sPane3.setDividerSize(4);
        sPane3.setDividerLocation(.50);
        sPane3.setResizeWeight(.50);
        JSplitPane sPane4=new JSplitPane(JSplitPane.VERTICAL_SPLIT,sPane3,sScroll);
        sPane4.setDividerSize(4);
        sPane4.setDividerLocation(.25);
        sPane4.setResizeWeight(.50);
        content.add(sPane4,BorderLayout.CENTER);
        initOtherPopups();
        if(mainFont!=null)updateFont(mainFont);
                updateTabSize(tabsize);
        updateWordWrap(wrap);
        setName("GBJ Browser Window");
	// 27993: remove setNextFocusableComponent
        //symbolDictionaries.setNextFocusableComponent(classes);
        //sDScroll.setNextFocusableComponent(classes);
        //classes.setNextFocusableComponent(protocol);
        classes.addFocusListener(this);
        //cScroll.setNextFocusableComponent(protocol);
        //protocol.setNextFocusableComponent(methods);
        //pScroll.setNextFocusableComponent(methods);
        //methods.setNextFocusableComponent(symbolDictionaries);
        //mScroll.setNextFocusableComponent(symbolDictionaries);
        methods.addFocusListener(this);
        protocol.addFocusListener(this);
        symbolDictionaries.addFocusListener(this);
        displayWindow();
        ySize=getHeight();
        xSize=getWidth();
        selectedComponent=workspace;
    }
    
    protected void initOtherPopups(){
        dictPopup=new JPopupMenu();
        classPopup = new JPopupMenu();
        protoPopup = new JPopupMenu();
        methodPopup = new JPopupMenu();
        JMenuItem temp=new JMenuItem("File Out As...");
        temp.setActionCommand("File Out As Dictionary");
        temp.setName("File Out As Dictionary JMenuItem JPopupMenu");
        temp.addActionListener(this);
        dictPopup.add(temp);
        dictPopup.addSeparator();
        temp=new JMenuItem("Inspect");
        temp.setActionCommand("Inspect Dictionary");
        temp.setName("Inspect Dictionary JMenuItem JPopupMenu");
        temp.addActionListener(this);
        dictPopup.add(temp);
        dictPopup.addSeparator();
        temp=new JMenuItem("Add");
        temp.setActionCommand("Add Dictionary");
        temp.setName("Add Dictionary JMenuItem JPopupMenu");
        temp.addActionListener(this);
        dictPopup.add(temp);
        temp=new JMenuItem("Rename As...");
        temp.setActionCommand("Rename As Dictionary");
        temp.setName("Rename As Dictionary JMenuItem JPopupMenu");
        temp.addActionListener(this);
        dictPopup.add(temp);
        temp=new JMenuItem("Remove");
        temp.setActionCommand("Remove Dictionary");
        temp.setName("Remove Dictionary JMenuItem JPopupMenu");
        temp.addActionListener(this);
        dictPopup.add(temp);
        dictPopup.addSeparator();
        temp=new JMenuItem("Find Class");
        temp.setActionCommand("Find Class in Dictionary");
        temp.setName("Find Class in Dictionary JMenuItem JPopupMenu");
        temp.addActionListener(this);
        dictPopup.add(temp);
        
        temp=new JMenuItem("File Out As...");
        temp.setActionCommand("File Out As Class");
        temp.setName("File Out As Class JMenuItem JPopupMenu");
        temp.addActionListener(this);
        classPopup.add(temp);
        classPopup.addSeparator();
        temp=new JMenuItem("Browse Class");
        temp.setActionCommand("Browse Class");
        temp.setName("Browse Class JMenuItem JPopupMenu");
        temp.addActionListener(this);
        classPopup.add(temp);
        temp=new JMenuItem("Browse Hierarchy");
        temp.setActionCommand("Browse Hierarchy");
        temp.setName("Browse Heirarchy JMenuItem JPopupMenu");
        temp.addActionListener(this);
        classPopup.add(temp);
        temp=new JMenuItem("Browse Versions");
        temp.setActionCommand("Browse Versions");
        temp.setName("Browse Versions JMenuItem JPopupMenu");
        temp.addActionListener(this);
        classPopup.add(temp);
        classPopup.addSeparator();
        temp=new JMenuItem("References to Instance Variable");
        temp.setActionCommand("References to Instance Variable");
        temp.setName("References to Instance Variable JMenuItem JPopupMenu");
        temp.addActionListener(this);
        classPopup.add(temp);
        temp=new JMenuItem("References to Class Variable");
        temp.setActionCommand("References to Class Variable");
        temp.setName("References to Class Variable JMenuItem JPopupMenu");
        temp.addActionListener(this);
        classPopup.add(temp);
        temp=new JMenuItem("References to Class");
        temp.setActionCommand("References to Class");
        temp.setName("References to Class JMenuItem JPopupMenu");
        temp.addActionListener(this);
        classPopup.add(temp);
        classPopup.addSeparator();
        temp=new JMenuItem("Show Hierarchy");
        temp.setActionCommand("Show Hierarchy");
        temp.setName("Show Heirarchy JMenuItem JPopupMenu");
        temp.addActionListener(this);
        classPopup.add(temp);
        temp=new JMenuItem("Show Definition");
        temp.setActionCommand("Show Definition");
        temp.setName("Show Definition JMenuItem JPopupMenu");
        temp.addActionListener(this);
        classPopup.add(temp);
        temp=new JMenuItem("Show Comment");
        temp.setActionCommand("Show Comment");
        temp.setName("Show Comment JMenuItem JPopupMenu");
        temp.addActionListener(this);
        classPopup.add(temp);
        classPopup.addSeparator();
        temp=new JMenuItem("Move To...");
        temp.setActionCommand("Move To Class");
        temp.setName("Move To Class JMenuItem JPopupMenu");
        temp.addActionListener(this);
        classPopup.add(temp);
        temp=new JMenuItem("Remove");
        temp.setActionCommand("Remove Class");
        temp.setName("Remove Class JMenuItem JPopupMenu");
        temp.addActionListener(this);
        classPopup.add(temp);
        classPopup.addSeparator();
        temp=new JMenuItem("New Template");
        temp.setActionCommand("New Template Class");
        temp.setName("New Template Class JMenuItem JPopupMenu");
        temp.addActionListener(this);
        classPopup.add(temp);
        
        temp=new JMenuItem("Add...");
        temp.setActionCommand("Add Protocol");
        temp.setName("Add Protocol JMenuItem JPopupMenu");
        temp.addActionListener(this);
        protoPopup.add(temp);
        temp=new JMenuItem("Rename As...");
        temp.setActionCommand("Rename As Protocol");
        temp.setName("Rename As Protocol JMenuItem JPopupMenu");
        temp.addActionListener(this);
        protoPopup.add(temp);
        temp=new JMenuItem("Remove");
        temp.setActionCommand("Remove Protocol");
        temp.setName("Remove Protocol JMenuItem JPopupMenu");
        temp.addActionListener(this);
        protoPopup.add(temp);
        protoPopup.addSeparator();
        temp=new JMenuItem("Find Method...");
        temp.setActionCommand("Find Method Protocol");
        temp.setName("Find Method Protocol JMenuItem JPopupMenu");
        temp.addActionListener(this);
        protoPopup.add(temp);
        
        temp=new JMenuItem("File Out As...");
        temp.setActionCommand("File Out As Method");
        temp.setName("File Out As Method JMenuItem JPopupMenu");
        temp.addActionListener(this);
        methodPopup.add(temp);
        methodPopup.addSeparator();
        temp=new JMenuItem("Browse Method");
        temp.setActionCommand("Browse Method");
        temp.setName("Browse Method JMenuItem JPopupMenu");
        temp.addActionListener(this);
        methodPopup.add(temp);
        methodPopup.addSeparator();
        temp=new JMenuItem("Senders...");
        temp.setActionCommand("Senders");
        temp.setName("Senders Method JMenuItem JPopupMenu");
        temp.addActionListener(this);
        methodPopup.add(temp);
        temp=new JMenuItem("Implementors...");
        temp.setActionCommand("Implementors");
        temp.setName("Implementors Method JMenuItem JPopupMenu");
        temp.addActionListener(this);
        methodPopup.add(temp);
        temp=new JMenuItem("Messages");
        temp.setActionCommand("Messages");
        temp.setName("Messages Method JMenuItem JPopupMenu");
        temp.addActionListener(this);
        methodPopup.add(temp);
        methodPopup.addSeparator();
        temp=new JMenuItem("Move To...");
        temp.setActionCommand("Move To Method");
        temp.setName("Move To Method JMenuItem JPopupMenu");
        temp.addActionListener(this);
        methodPopup.add(temp);
        temp=new JMenuItem("Remove");
        temp.setActionCommand("Remove Method");
        temp.setName("Remove Method JMenuItem JPopupMenu");
        temp.addActionListener(this);
        methodPopup.add(temp);
        methodPopup.addSeparator();
        temp=new JMenuItem("View Class Only");
        temp.setActionCommand("View Class Methods");
        temp.setName("View Class Methods JMenuItem JPopupMenu");
        temp.addActionListener(this);
        methodPopup.add(temp);
        temp=new JMenuItem("View Up To Root");
        temp.setActionCommand("View Up To Root Methods");
        temp.setName("View Up To Root Methods JMenuItem JPopupMenu");
        temp.addActionListener(this);
        methodPopup.add(temp);
        temp=new JMenuItem("View Including Root");
        temp.setActionCommand("View Including Root Methods");
        temp.setName("View Including Root Methods JMenuItem JPopupMenu");
        temp.addActionListener(this);
        methodPopup.add(temp);
        methodPopup.addSeparator();
        temp=new JMenuItem("New Template");
        temp.setActionCommand("New Template Method");
        temp.setName("New Template Method JMenuItem JPopupMenu");
        temp.addActionListener(this);
        methodPopup.add(temp);
    }
    
    protected void initFileMenu() {
        JMenuItem tempMenuItem=new JMenuItem("Update");
        tempMenuItem.setName("Update MenuItem");
        tempMenuItem.setActionCommand("Update");
        tempMenuItem.addActionListener(this);
        fileMenu.add(tempMenuItem);
        fileMenu.addSeparator();
        tempMenuItem=new JMenuItem("Close");
        tempMenuItem.setName("Close MenuItem");
        tempMenuItem.setActionCommand("Close");
        tempMenuItem.addActionListener(this);
        fileMenu.add(tempMenuItem);
    }
    
    protected void initCustomMenus() {
        dictionaryMenu = new JMenu("Dictionary");
        dictionaryMenu.setName("Dictionary Menu");
        classMenu = new JMenu("Class");
        classMenu.setName("Class Menu");
        protocolMenu= new JMenu("Protocol");
        protocolMenu.setName("Protocol Menu");
        methodMenu= new JMenu("Method");
        methodMenu.setName("Method Menu");
    }
    
    protected void addCustomMenus() {
        addDictionaryMenu();
        addClassMenu();
        addProtocolMenu();
        addMethodMenu();
    }
    
    protected void addMethodMenu() {
        JMenuItem tMenu=new JMenuItem("File Out As");
        tMenu.addActionListener(this);
        tMenu.setActionCommand("File Out As Method");
        methodMenu.add(tMenu);
        methodMenu.addSeparator();
        tMenu=new JMenuItem("Browse Method");
        tMenu.setActionCommand("Browse Method");
        tMenu.addActionListener(this);
        methodMenu.add(tMenu);
        tMenu=new JMenuItem("Senders");
        tMenu.setActionCommand("Senders");
        tMenu.addActionListener(this);
        methodMenu.add(tMenu);
        tMenu=new JMenuItem("Implementors");
        tMenu.setActionCommand("Implementors");
        tMenu.addActionListener(this);
        methodMenu.add(tMenu);
        tMenu=new JMenuItem("Messages");
        tMenu.setActionCommand("Messages");
        tMenu.addActionListener(this);
        methodMenu.add(tMenu);
        tMenu=new JMenuItem("Move To");
        tMenu.setActionCommand("Move To Method");
        tMenu.addActionListener(this);
        methodMenu.add(tMenu);
        tMenu=new JMenuItem("Remove");
        tMenu.setActionCommand("Remove Method");
        tMenu.addActionListener(this);
        methodMenu.add(tMenu);
/* 16462: commenting out menu option that never had implementation code built.
        methodMenu.addSeparator();
        JMenu viewMenu=new JMenu("View");
        methodMenu.add(viewMenu);
        tMenu=new JMenuItem("Class Only");
        tMenu.setActionCommand("View Class Only");
        tMenu.addActionListener(this);
        viewMenu.add(tMenu);
        tMenu=new JMenuItem("Up To Root");
        tMenu.setActionCommand("View Up To Root Methods");
        tMenu.addActionListener(this);
        viewMenu.add(tMenu);
        tMenu=new JMenuItem("Including Root");
        tMenu.setActionCommand("View Including Root Methods");
        tMenu.addActionListener(this);
        viewMenu.add(tMenu);
        methodMenu.addSeparator();
*/
        tMenu=new JMenuItem("New Template");
        tMenu.setActionCommand("New Template Method");
        tMenu.addActionListener(this);
        methodMenu.add(tMenu);
        menuBar.add(methodMenu);
    }
    
    protected void addProtocolMenu(){
        JMenuItem tMenu=new JMenuItem("Add");
        tMenu.setActionCommand("Add Protocol");
        tMenu.addActionListener(this);
        protocolMenu.add(tMenu);
        tMenu=new JMenuItem("Rename As");
        tMenu.setActionCommand("Rename As Protocol");
        tMenu.addActionListener(this);
        protocolMenu.add(tMenu);
        tMenu=new JMenuItem("Remove");
        tMenu.setActionCommand("Remove Protocol");
        tMenu.addActionListener(this);
        protocolMenu.add(tMenu);
        protocolMenu.addSeparator();
        tMenu=new JMenuItem("Find Method");
        tMenu.setActionCommand("Find Method Protocol");
        tMenu.addActionListener(this);
        protocolMenu.add(tMenu);
        menuBar.add(protocolMenu);
    }
    
    protected void addClassMenu() {
        JMenu cBrowseMenu;
        JMenu cReferencesMenu;
        JMenu cShowMenu;
        JMenuItem tMenu=new JMenuItem("File Out As");
        tMenu.addActionListener(this);
        tMenu.setActionCommand("File Out As Class");
        classMenu.add(tMenu);
        classMenu.addSeparator();
        cBrowseMenu=new JMenu("Browse");
        classMenu.add(cBrowseMenu);
        tMenu=new JMenuItem("Class");
        tMenu.setActionCommand("Browse Class");
        tMenu.addActionListener(this);
        cBrowseMenu.add(tMenu);
        tMenu=new JMenuItem("Hierarchy");
        tMenu.setActionCommand("Browse Hierarchy");
        tMenu.addActionListener(this);
        cBrowseMenu.add(tMenu);
        tMenu=new JMenuItem("Versions");
        tMenu.setActionCommand("Browse Versions");
        tMenu.addActionListener(this);
        cBrowseMenu.add(tMenu);
        cReferencesMenu=new JMenu("References To");
        classMenu.add(cReferencesMenu);
        tMenu=new JMenuItem("Instance Variables");
        tMenu.setActionCommand("References to Instance Variable");
        tMenu.addActionListener(this);
        cReferencesMenu.add(tMenu);
        tMenu=new JMenuItem("Class Variables");
        tMenu.setActionCommand("References to Class Variable");
        tMenu.addActionListener(this);
        cReferencesMenu.add(tMenu);
        tMenu=new JMenuItem("Class");
        tMenu.setActionCommand("References to Class");
        tMenu.addActionListener(this);
        cReferencesMenu.add(tMenu);
        cShowMenu=new JMenu("Show");
        classMenu.add(cShowMenu);
        tMenu=new JMenuItem("Hierarchy");
        tMenu.setActionCommand("Show Hierarchy");
        tMenu.addActionListener(this);
        cShowMenu.add(tMenu);
        tMenu=new JMenuItem("Definition");
        tMenu.setActionCommand("Show Definition");
        tMenu.addActionListener(this);
        cShowMenu.add(tMenu);
        tMenu=new JMenuItem("Comment");
        tMenu.setActionCommand("Show Comment");
        tMenu.addActionListener(this);
        cShowMenu.add(tMenu);
        classMenu.addSeparator();
        tMenu=new JMenuItem("Move To");
        tMenu.setActionCommand("Move To Class");
        tMenu.addActionListener(this);
        classMenu.add(tMenu);
        tMenu=new JMenuItem("Remove");
        tMenu.setActionCommand("Remove Class");
        tMenu.addActionListener(this);
        classMenu.add(tMenu);
        tMenu=new JMenuItem("New Template");
        tMenu.setActionCommand("New Template Class");
        tMenu.addActionListener(this);
        classMenu.add(tMenu);
        menuBar.add(classMenu);
    }
    
    protected void addDictionaryMenu() {
        JMenuItem tMenu=new JMenuItem("File Out As");
        tMenu.setActionCommand("File Out As Dictionary");
        tMenu.addActionListener(this);
        dictionaryMenu.add(tMenu);
        dictionaryMenu.addSeparator();
        tMenu=new JMenuItem("Inspect");
        tMenu.setActionCommand("Inspect Dictionary");
        tMenu.addActionListener(this);
        dictionaryMenu.add(tMenu);
        dictionaryMenu.addSeparator();
        tMenu=new JMenuItem("Add");
        tMenu.setActionCommand("Add Dictionary");
        tMenu.addActionListener(this);
        dictionaryMenu.add(tMenu);
        tMenu=new JMenuItem("Rename As");
        tMenu.addActionListener(this);
        tMenu.setActionCommand("Rename As Dictionary");
        dictionaryMenu.add(tMenu);
        tMenu=new JMenuItem("Remove");
        tMenu.setActionCommand("Remove Dictionary");
        tMenu.addActionListener(this);
        dictionaryMenu.add(tMenu);
        dictionaryMenu.addSeparator();
        tMenu=new JMenuItem("Find Class");
        tMenu.setActionCommand("Find Class in Dictionary");
        tMenu.addActionListener(this);
        dictionaryMenu.add(tMenu);
        menuBar.add(dictionaryMenu);
    }
    
    protected void initEditMenuAdvanced() {
        JMenuItem tempMenuItem=new JMenuItem("Do-It");
        tempMenuItem.setActionCommand("Do-It");
        tempMenuItem.addActionListener(this);
        tempMenuItem.setName("doitMenuItem");
        editMenu.add(tempMenuItem);
        tempMenuItem=new JMenuItem("Print-It");
        tempMenuItem.setActionCommand("Print-It");
        tempMenuItem.addActionListener(this);
        tempMenuItem.setName("printitMenuItem");
        editMenu.add(tempMenuItem);
        tempMenuItem=new JMenuItem("Inspect-It");
        tempMenuItem.setActionCommand("Inspect-It");
        tempMenuItem.addActionListener(this);
        tempMenuItem.setName("inspectitMenuItem");
        editMenu.add(tempMenuItem);
        editMenu.addSeparator();
        tempMenuItem=new JMenuItem("Compile");
        tempMenuItem.setActionCommand("Compile");
        tempMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,ActionEvent.CTRL_MASK));
        tempMenuItem.addActionListener(this);
        tempMenuItem.setName("compileMenuItem");
        editMenu.add(tempMenuItem);
        editMenu.addSeparator();
        tempMenuItem=new JMenuItem("Cancel");
        tempMenuItem.setActionCommand("Cancel");
        tempMenuItem.addActionListener(this);
        tempMenuItem.setName("cancelMenuItem");
        editMenu.add(tempMenuItem);
        editMenu.addSeparator();
        tempMenuItem=new JMenuItem("Set Break");
        tempMenuItem.setActionCommand("Set Break");
        tempMenuItem.addActionListener(this);
        tempMenuItem.setName("setbreakMenuItem");
        editMenu.add(tempMenuItem);
    }
    
    protected void initSessionMenu() {
        JMenuItem tempMenuItem=new JMenuItem("Commit");
        tempMenuItem.addActionListener(this);
        tempMenuItem.setName("commitMenuItem");
        tempMenuItem.setActionCommand("Commit");
        tempMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,ActionEvent.CTRL_MASK+ActionEvent.SHIFT_MASK));
        sessionMenu.add(tempMenuItem);
        tempMenuItem=new JMenuItem("Abort");
        tempMenuItem.setActionCommand("Abort");
        tempMenuItem.addActionListener(this);
        tempMenuItem.setName("abortMenuItem");
        sessionMenu.add(tempMenuItem);
        tempMenuItem=new JMenuItem("Begin");
        tempMenuItem.setActionCommand("Begin");
        tempMenuItem.addActionListener(this);
        tempMenuItem.setName("beginMenuItem");
        sessionMenu.add(tempMenuItem);
    }
    
    public void actionPerformed(java.awt.event.ActionEvent actionEvent) {
        String actionItem=actionEvent.getActionCommand();
        if(actionItem.equals("File Out As Dictionary")){
            fileOutDictionary();
        }else if(actionItem.equals("Inspect Dictionary")){
            inspectDictionary();
        }else if(actionItem.equals("Rename As Dictionary")){
            renameDictionary();
        }else if(actionItem.equals("Add Dictionary")){
            addDictionary();
        }else if(actionItem.equals("Remove Dictionary")){
            removeDictionary();
        }else if(actionItem.equals("Find Class in Dictionary")){
            findClass();
        }else if(actionItem.equals("File Out As Class")){
            fileOutClass();
        }else if(actionItem.equals("Browse Class")){
            browseClass();
        }else if(actionItem.equals("Browse Hierarchy")){
            browseHierarchy();
        }else if(actionItem.equals("Browse Versions")){
            browseVersions();
        }else if(actionItem.equals("References to Instance Variable")){
            browseInstVarRefs();
        }else if(actionItem.equals("References to Class Variable")){
            browseClassVarRefs();
        }else if(actionItem.equals("References to Class")){
            browseClassRefs();
        }else if(actionItem.equals("Show Hierarchy")){
            showHierarchy();
        }else if(actionItem.equals("Show Definition")){
            showDefinition();
        }else if(actionItem.equals("Show Comment")){
            showComment();
        }else if(actionItem.equals("Move To Class")){
            moveClass();
        }else if(actionItem.equals("Remove Class")){
            removeClass();
        }else if(actionItem.equals("New Template Class")){
            showClassTemplate();
        }else if(actionItem.equals("Add Protocol")){
            addProtocol();
        }else if(actionItem.equals("Rename As Protocol")){
            renameProtocol();
        }else if(actionItem.equals("Remove Protocol")){
            removeProtocol();
        }else if(actionItem.equals("Find Method Protocol")){
            findMethod();
        }else if(actionItem.equals("File Out As Method")){
            fileOutMethod();
        }else if(actionItem.equals("Browse Method")){
            browseMethod();
        }else if(actionItem.equals("Senders")){
            browseSenders();
        }else if(actionItem.equals("Implementors")){
            browseImplementors();
        }else if(actionItem.equals("Messages")){
            browseMessages();
        }else if(actionItem.equals("Move To Method")){
            moveMethod();
        }else if(actionItem.equals("Remove Method")){
            removeMethod();
        }else if(actionItem.equals("View Class Only")){
            browseClassOnly();
        }else if(actionItem.equals("View Up To Root")){
            browseExcludingRoot();
        }else if(actionItem.equals("View Including Root")){
            browseIncludingRoot();
        }else if(actionItem.equals("New Template Method")){
            showMethodTemplate();
        }else if(actionItem.equals("Compile")){
            acceptText();
        }else if(actionItem.equals("Cancel")){
            cancelText();
        }else if(actionItem.equals("Set Break")){
            setBreak();
        }else if(actionItem.equals("Update")){
            update();
        }else if(actionItem.equals("Instance")){
            instanceButtonSelected();
        }else if(actionItem.equals("Class")){
            classButtonSelected();
        }else
            super.actionPerformed(actionEvent);
    }
    
    protected void initHelpMenu() {
    }
    
    public void updateFont(Font font) {
        workspace.setFont(font);
        protocol.setFont(font);
        classes.setFont(font);
        methods.setFont(font);
        symbolDictionaries.setFont(font);
    }
    
    protected void update() {
        /* Refresh the browser. */
        this.resetClassOrganizer();
        this.reinitialize();
    }
    
    protected  void browseExcludingRoot() {
        browseLevel = 2;
        resetClass();
    }
    
    protected  void browseIncludingRoot() {
        browseLevel = 1;
        resetClass();
    }
    
    protected  void resetClass() {
        /* Reset the browser trying to preserve the class list selection. */
        class_(selectedClass());
    }
    
    protected  void class_protocol_method_(GbxClassHolder aClassHolder, String aProtocol, GbxMethodHolder aMethodHolder) {
   /* Reset the class list selection to <aClassHolder>, the protocol
   list selection to <aProtocol> and the method list selection to
   <aMethodHolder>. */
        this.class_protocolList_protocol_methodList_method_(aClassHolder, null, aProtocol, null, aMethodHolder);
    }
    
    protected  GbxClassHolder selectedClass() {
        /* Return the currently selected class holder. */
        
        int index;
        
        if (classes == null) {
            return null;
        }
        index = classes.getSelectedIndex();
        return index < 0
        ? null
        : this.classList()[index];
    }
    
    public void componentResized(java.awt.event.ComponentEvent componentEvent) {
        int x=(getWidth()-12)/4;
        int y=(getHeight()-35)/3;
        if(getWidth()<455||getHeight()<255){
            if((x*4)<455){
                x=(460-12)/4;
                setSize(460,getHeight());
            }
            if((y*3)<255){
                y=(260-35)/3;
                setSize(getWidth(),260);
            }
        }
        if(xSize==getWidth()&&ySize==getHeight())return;
        listPanel.invalidate();
        buttonPanel.invalidate();
        sScroll.setPreferredSize(new Dimension(x*4,y*2));
        mScroll.setPreferredSize(new Dimension(x+20,y));
        mScroll.invalidate();
        pScroll.setPreferredSize(new Dimension(x-20,y));
        pScroll.invalidate();
        sDScroll.setPreferredSize(new Dimension(x-20,y));
        sDScroll.invalidate();
        cScroll.setPreferredSize(new Dimension(x+20,y-25));
        sScroll.invalidate();
        validate();
        xSize=getWidth();
        ySize=getHeight();
    }
    
    protected   void textMode_(String aSymbol) {
        /* Keep track of the current mode of display for the text pane. */
        textMode = aSymbol;
    }
    
    protected  String textForOldClass() {
        /*  Show definition of selected class */
        
        return this.classDefinitionFor_(this.selectedNonMetaclass());
    }
    protected   String textForNewMethod() {
        /* Return the text for the template of a new method. */
        return com.gemstone.gbj.GbxConstants.methodString;
    }
    
    protected   String textForNewClass() {
        /* Show the class creation template */
        
        String inDictName;
        
        inDictName = this.dictionaryName();
        if (inDictName == null ) {
            inDictName = "UserGlobals" ;
        };
	String postClassDef = GbxConstants.postClassDefinition;
        return GbxConstants.preClassDefinition + inDictName + postClassDef;
    }
    
    protected    String textForMethod() {
        /* Show method text for selected method */
        String aSelector;
        
        aSelector = this.selectedMethod().name();
        return this.sourceCodeAt_inClass_(aSelector, this.methodClassProxy());
    }
    
    protected   GbjObject selectedNonMetaclass() {
        /* Return a proxy for the selected class. */
        
        GbxClassHolder aClass;
        
        return ((aClass = this.selectedClass()) == null)
        ? null
        : aClass.proxy();
    }
    
    protected    String classDefinitionFor_(GbjObject anObject) {
        String definition = "Could not access class definition";
        
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            definition = this.serverSupport().classDefinitionFor_(anObject);
        } catch (GbjException e) {
            this.processError_(e);
        }
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        return definition;
    }
    
    protected   boolean acceptClassOrMethodText(String aString) {
        /* If no class is selected, accept a new class definition*/
        if (this.selectedClass() == null) {
            return this.acceptClassText(aString);
        }
        
        /* A real class is selected with no textMode; accept the old class definition*/
        if (this.selectedProtocol() == null) {
            if ((textMode == null) || (textMode.equals("classDefinition"))) {
                return this.acceptClassText(aString);
            }
            if (textMode.equals("hierarchy")) {
                /* Do nothing */
                return true;
            }
            if (textMode.equals("comment")) {
                /* Do nothing */
                return true;
            }
            return true;
        }
        /* A protocol is selected; accept new method text */
        return this.compileMethod(aString);
    }
    
    String dictionaryName() {
   /* Return the name of the currently selected symbol list
   dictionary. */
        
        return this.selectedDictionary() == null
        ? null
        : this.selectedDictionary().name();
    }
    
    protected GbxMethodHolder selectedMethod() {
        /** Return the currently selected method holder. */
        
        int index;
        
        if (methods == null) {
            return null;
        }
        index = methods.getSelectedIndex();
        return index < 0
        ? null
        : this.methodList()[index];
    }
    
    GbjObject methodClassProxy() {
        return this.selectedMethod().remoteClass();
    }
    
    String sourceCodeAt_inClass_(String selector, GbjObject aClass) {
        String txt = "Could not access source";
        
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            txt = this.serverSupport().sourceCodeAt_inClass_(selector, aClass);
        } catch (GbjException e) {
            this.processError_(e);
        }
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        return txt;
    }
    
    boolean acceptClassText(String aString) {
   /* <aString> is expected to be a class definition.  If there is a selected class, the new definition is
   probably a new version of the selected class.  If no class is selected, the new definition is
   probably a new class.  In neither case are we sure, however.  We really should parse what is
   in the class definition text before doing the execute to be able to tell the difference. */
        
        GbjObject oldClass;
        GbjObject newClass;
        GbjObject [] infoProxies;
        String result;
        String newClassName;
        GbjObject classObj;
        String className;
        String sel;
        String src;
        String cat;
        String dString;
        GbxMethodHolder [] failedMethods;
        
        try {
            oldClass = this.selectedNonMetaclass();
            infoProxies = this.serverSupport().acceptClassText_oldClass_(aString, oldClass);
            
            result = infoProxies[0].stringValue();
            /* Make sure we compiled to a class object. */
            if (!(result.equals("New class"))) {
                JOptionPane.showMessageDialog(this, "The string you entered does not create a class object","Save Class",JOptionPane.ERROR_MESSAGE);
                return false;
            }
            
            newClass = infoProxies[1];
            newClassName = infoProxies[2].stringValue();
            
            /* Update the browser, trying to select the new class. */
            this.postAcceptForClass_(new GbxClassHolder(newClassName, newClass));
            if (infoProxies.length > 3) {
                failedMethods = new GbxMethodHolder[(infoProxies.length - 3) / 7];
                for (int i = 3; i < infoProxies.length; i += 7) {
                    classObj = infoProxies[i + 1];
                    className = infoProxies[i + 2].stringValue();
                    sel = infoProxies[i + 3].stringValue();
                    src = infoProxies[i + 4].stringValue();
                    cat = infoProxies[i + 5].stringValue();
                    dString = infoProxies[i + 6].stringValue();
                    failedMethods[(i - 3) / 7] = new GbxMethodHolder(sel, null, classObj, className, dString, cat, -1, src);
                }
                GbjMethodListBrowser mlb=new GbjMethodListBrowser(session,launcher);
                mlb.openListBrowserOn_label_session_launcher_(failedMethods,
                "GBJ Methods Failing Compilation", session, launcher);
            }
            return true;
        } catch (GbjException e) {
            workspace.select(0, 0);
            this.processGbjException(e);
            return false;
        }
    }
    
    String selectedProtocol() {
        /* Return the currently selected protocol. */
        
        int index;
        
        if (protocol == null) {
            return null;
        }
        index = protocol.getSelectedIndex();
        return index < 0
        ? null
        : this.protocolList()[index];
    }
    
    boolean compileMethod(String aString) {
        GbjObject result;
        String newSelector;
        GbjObject method;
        Vector methodInfo;
        boolean noError;
        String warning;
        GbjObject targetClass;
        
        targetClass = this.selectedMethod() == null
        ? this.selectedClassOrMetaclass()
        : this.methodClassProxy();
        
        /* Compile it. */
        methodInfo = this.compile_classified_class_(aString, this.selectedProtocol(), targetClass);
        if (methodInfo.size() == 0) {
            /* Non-compilation related exception; already reported */
            return false;
        }
        noError = ((Boolean) methodInfo.elementAt(0)).booleanValue();
        if (!noError) {
            this.showCompilerErrorArray(methodInfo);
            return false;
        }
        method = (GbjObject) methodInfo.elementAt(1);
        newSelector = (String) methodInfo.elementAt(2);
        warning = (String) methodInfo.elementAt(3);
        if (warning.length() != 0) {
            this.showWarningMessage(warning);
        }
        
        /* Cause method list for this category to update, keeping current method selected */
        if (newSelector == null) {
            return false;
        }
        this.protocol_method_(this.selectedProtocol(), new GbxMethodHolder(newSelector, method));
        return true;
    }
    
    GbxDictionaryHolder selectedDictionary() {
        /* Return the currently selected symbol list dictionary. */
        
        int index;
        
        if (symbolDictionaries == null) {
            return null;
        }
        index = symbolDictionaries.getSelectedIndex();
        return index < 0
        ? null
        : this.dictionaryList()[index];
    }
    
    void dictionary_(GbxDictionaryHolder aDict) {
   /* Reset the dictionary list selection to <aDict> while trying to
   preserve the class, protocol and method selections. */
        
        this.dictionary_class_protocol_method_(aDict,
        this.selectedClass(), this.selectedProtocol(),
        this.selectedMethod());
    }
    
    GbxClassHolder [] getClassList() {
   /* Retrieve the list of classes in the currently selected
   dictionary from GemStone.  Create and return class holders
   for each. */
        
        if (this.selectedDictionary() == null) {
            return new GbxClassHolder[0];
        } else {
            return this.classHoldersFor_(this.selectedDictionaryProxy());
        }
    }
    
    String [] instProtocolListToLevel_(int aLevel) {
   /* Returns an array of strings representing the instance method
   categories of the current class */
        
        return this.protocolListForClass_toLevel_(this.selectedNonMetaclass(), aLevel);
    }
    
    void resetText() {
   /* Reset the text pane with text appropriate for the current
   selections and mode. */
        workspace.setText(this.text());
        workspace.setCaretPosition(0);
    }
    
    void classList_class_protocolList_protocol_methodList_method_(GbxClassHolder [] cList, GbxClassHolder aClassHolder, String [] pList, String aProtocol, GbxMethodHolder [] mList, GbxMethodHolder aMethodHolder) {
   /* Reset the browser given the individual selections and lists
   supplied by the arguments. */
        
        classList = (cList == null) ? this.getClassList() : cList;
        this.updateListWidget_withObjects_(classes, classList);
        this.class_protocolList_protocol_methodList_method_(aClassHolder, pList, aProtocol, mList, aMethodHolder);
    }
    
    String [] getProtocolListToLevel_(int aLevel) {
        /* Get the protocol list of the currently selected class. */
        
        if (this.selectedClass() == null ) {
            return new String[0];
        }
        return this.isInstance() ? this.instProtocolListToLevel_(aLevel) : this.classProtocolListToLevel_(aLevel);
    }
    
    GbxMethodHolder methodHolderFor_(GbxMethodHolder aHolder) {
   /* Return a method holder from the current list of methods that
   matches <aHolder>. */
        GbxMethodHolder listHolder = null;
        String holderString;
        
        if (aHolder == null) {
            return null;
        }
        if (aHolder.proxy() != null) {
            listHolder = (GbxMethodHolder) this.holderFor_fromList_(aHolder, this.methodList());
        }
        if (listHolder != null) {
            return listHolder;
        }
        holderString = aHolder.displayString();
        for (int i = 0; i < methodList().length; i++) {
            listHolder = methodList[i];
            if (listHolder.displayString().equals(holderString)) {
                return listHolder;
            }
        }
        return null;
    }
    
    String [] protocolListForClass_toLevel_(GbjObject aClass, int aLevel) {
   /* Returns an array of strings representing the method
   categories of <aClass>. */
        
        return this.protocolHoldersFor_toLevel_(aClass, aLevel);
    }
    
    GbjObject selectedMetaclass() {
        /* Return a proxy for the metaclass of the selected class. */
        
        GbxClassHolder aClass;
        
        return ((aClass = this.selectedClass()) == null)
        ? null
        : aClass.metaclass();
    }
    
    void resetDictionaryList_selecting_(GbxDictionaryHolder [] aList, GbxDictionaryHolder aDict) {
   /* Reset the dictionary list to <aList> while trying to select
   <aDict> and preserve other selections. */
        
        this.dictionaryList_dictionary_classList_class_protocolList_protocol_methodList_method_(aList,
        aDict, null, this.selectedClass(), null, this.selectedProtocol(), null, this.selectedMethod());
    }
    
    GbxClassHolder [] classList() {
        /* Return the class list. */
        
        return (classList == null) ? classList = new GbxClassHolder[0] : classList;
    }
    
    GbxClassHolder classHolderFor_(GbxClassHolder aHolder) {
   /* Return a class holder from the current list of classes that
   matches <aHolder>. */
        
        return (GbxClassHolder) this.holderFor_fromList_(aHolder, this.classList());
    }
    
    void resetMethod() {
   /* Reset the browser trying to preserve the method list
   selection. */
        
        this.method_(this.selectedMethod());
    }
    
    void protocolList_protocol_methodList_method_(String [] pList, String aProtocol, GbxMethodHolder [] mList, GbxMethodHolder aMethodHolder) {
   /* Reset the browser given the individual selections and lists
   supplied by the arguments. */
        
        protocolList = (pList == null ) ? this.getProtocolListToLevel_(browseLevel) : pList;
        this.updateListWidget_withObjects_(protocol, protocolList);
        this.protocol_methodList_method_(aProtocol, mList, aMethodHolder);
    }
    
    GbxMethodHolder [] classMethodList() {
   /* Returns an array of strings representing the instance
   methods of the current class */
        
        return this.methodHoldersFor_inProtocol_(this.selectedMetaclass(), this.selectedProtocol());
    }
    
    void resetClassListSelecting_(GbxClassHolder aClass) {
   /* Reset the class list to the default while trying to select class
   <aClass>. */
        
        this.classList_class_protocolList_protocol_methodList_method_(null, aClass, null, this.selectedProtocol(), null, this.selectedMethod());
    }
    
    void method_(GbxMethodHolder aMethodHolder) {
   /* Reset the method list selection to <aMethodHolder>.  Update
   the text pane. */
        
        GbxMethodHolder mthHolder;
        int index;
        
        mthHolder = this.methodHolderFor_(aMethodHolder);
        this.changeSelectionTo_from_widget_holders_(mthHolder,
        this.selectedMethod(), methods, methodList);
        this.resetText();
    }
    
    GbjObject selectedDictionaryProxy() {
   /* Return the proxy of the currently selected symbol list
   dictionary. */
        
        return this.selectedDictionary() == null
        ? null
        : this.selectedDictionary().proxy();
    }
    
    GbxMethodHolder [] getMethodList() {
   /* Return the list of methods to be displayed in the browser
   based on the currently selected class, the currently selected
   protocol and the class/instance switch. */
        
        if (this.selectedClass() == null) {
            return new GbxMethodHolder[0];
        }
        return (this.isInstance()) ? this.instMethodList() : this.classMethodList();
    }
    
    public void classSelected() {
   /* This message is sent from the u/i only to indicate list
   selection from the class list. */
        
        this.resetClass();
    }
    
    public void protocolSelected() {
   /* This message is sent from the u/i only to indicate list
   selection from the protocol list.  Undo the hierarchy/comment
   selection; then reset the selected protocol */
        
        this.textMode_(null);
        LastProtocol = this.selectedProtocol();
        this.resetProtocol();
    }
    
    void protocol_methodList_method_(String aProtocol, GbxMethodHolder [] mList, GbxMethodHolder aMethodHolder) {
   /* Reset the browser given the individual selections and list
   supplied by the arguments. */
        
        String pHolder;
        int index;
        
        pHolder = this.protocolHolderFor_(aProtocol);
        this.changeSelectionTo_from_widget_holders_(pHolder,
        this.selectedProtocol(), protocol, protocolList);
        this.methodList_method_(mList, aMethodHolder);
    }
    
    void resetClassSelectingProtocol_(String aProtocol) {
   /* Reset the browser preserving the class list selection while
   selecting protocol <aProtocol>. */
        
        this.class_protocol_(this.selectedClass(), aProtocol);
    }
    
    void resetDictionaryListSelecting_(GbxDictionaryHolder aDictionary) {
   /* Reset the dictionary list to the default while trying to select
   dictionary <aDictionary> and preserve other selections. */
        
        this.dictionaryList_dictionary_classList_class_protocolList_protocol_methodList_method_(null, aDictionary, null, this.selectedClass(), null, this.selectedProtocol(), null, this.selectedMethod());
    }
    
    public void instanceButtonSelected() {
   /* This is sent from the user interface when the 'instance' toggle
   is selected. */
        
        this.isInstance_(true);
        this.resetClass();
    }
    
    String [] classProtocolListToLevel_(int aLevel) {
   /* Returns an array of strings representing the class method
   categories of the current class */
        
        return this.protocolListForClass_toLevel_(this.selectedMetaclass(), aLevel);
    }
    
    GbxMethodHolder [] instMethodList() {
   /* Returns an array of holders representing the instance
   methods of the current class */
        
        return this.methodHoldersFor_inProtocol_(this.selectedNonMetaclass(), this.selectedProtocol());
    }
    
    boolean protocolExists_(String aProtocol) {
   /* Return true if <aProtocol> is currently one of the protocols
   in the selected class; false otherwise. */
        
        String [] aList = this.getProtocolListToLevel_(-1);
        
        return this.protocolExists_inList_(aProtocol, aList);
    }
    
    boolean protocolExists_inList_(String aProtocol, String [] aList) {
        for (int i = 0; i < aList.length; i++) {
            if (aList[i].equals(aProtocol)) {
                return true;
            }
        }
        return false;
    }
    
    public void classButtonSelected() {
   /* This is sent from the user interface when the 'class' toggle is
   selected. */
        
        this.isInstance_(false);
        this.resetClass();
    }
    
    
    public void dictionarySelected() {
   /* This message is sent from the u/i only to indicate list
   selection from the dictionary list. */
        
        this.resetDictionary();
    }
    
    void class_(GbxClassHolder aClassHolder) {
   /* Reset the class list selection to <aClassHolder> while trying
   to preserve the protocol and method selections. */
        this.class_protocol_method_(aClassHolder, this.selectedProtocol(), this.selectedMethod());
    }
    
    void resetDictionary() {
   /* Reset the browser trying to preserve the dictionary list
   selection. */
        
        this.dictionary_(this.selectedDictionary());
    }
    
    void dictionary_class_protocol_method_(GbxDictionaryHolder aDictHolder, GbxClassHolder aClassHolder, String aProtocol, GbxMethodHolder aMethodHolder) {
   /* Reset the dictionary list selection to <aDict>, the class list
   selection to <aClass>, the protocol list selection to <aProtocol>
   and the method list selection to <aMethodHolder>. */
        
        this.dictionary_classList_class_protocolList_protocol_methodList_method_(aDictHolder, null, aClassHolder, null, aProtocol, null , aMethodHolder);
    }
    
    void resetDictionarySelectingClass_(GbxClassHolder aClass) {
   /* Reset the dictionary list selection to the current selection
   while trying to select <aClass> in the class list. */
        
        this.dictionary_class_(this.selectedDictionary(), aClass);
    }
    
    void protocol_method_(String aProtocol, GbxMethodHolder aMethodHolder) {
   /* Reset the protocol list selection to <aProtocol> and the
   method list selection to <aMethodHolder>. */
        
        this.protocol_methodList_method_(aProtocol, null, aMethodHolder);
    }
    
    void dictionary_class_(GbxDictionaryHolder aDict, GbxClassHolder aClass) {
   /* Reset the dictionary list selection to <aDict> and the class
   list selection to <aClass>  while trying to preserve the protocol
   and method selections. */
        
        this.dictionary_class_protocol_method_(aDict, aClass, this.selectedProtocol(), this.selectedMethod());
    }
    
    void class_protocolList_protocol_methodList_method_(GbxClassHolder aClassHolder, String [] pList, String aProtocol, GbxMethodHolder [] mList, GbxMethodHolder aMethodHolder) {
   /* Reset the browser given the individual selections and lists
   supplied by the arguments. */
        GbxClassHolder clsHolder;
        int index;
        
        clsHolder = this.classHolderFor_(aClassHolder);
        this.changeSelectionTo_from_widget_holders_(clsHolder,
        this.selectedClass(), classes, classList);
        this.protocolList_protocol_methodList_method_(pList, aProtocol, mList, aMethodHolder);
    }
    
    void resetProtocol() {
   /* Reset the browser trying to preserve the protocol list
   selection. */
        
        this.protocol_(this.selectedProtocol());
    }
    
    String text() {
        return (this.selectedDictionary() == null)
        ? new String()
        : this.textForClassOrMethod();
    }
    
    void methodList_method_(GbxMethodHolder [] mList, GbxMethodHolder aMethodHolder) {
   /* Reset the browser given the individual selection and list
   supplied by the arguments. */
        
        methodList = (mList == null ) ? this.getMethodList() : mList;
        this.updateListWidget_withObjects_(methods, methodList);
        this.method_(aMethodHolder);
    }
    
    String protocolHolderFor_(String aHolder) {
        String listString;
        String [] aList;
        
        if (aHolder == null) {
            return null;
        }
        aList = this.protocolList();
        for (int i = 0; i < aList.length; i++) {
            listString = aList[i];
            if (listString == aHolder) {
                return listString;
            }
        }
        for (int i = 0; i < aList.length; i++) {
            listString = aList[i];
            if (listString.equals(aHolder)) {
                return listString;
            }
        }
        return null;
    }
    
    void reinitialize() {
   /* Reinitialize the browser trying to maintain current selections
   and taking into account the browser type. */
        
        this.resetDictionaryList();
    }
    
    boolean classInst() {
        /* Return the value holder for the class/instance toggles. */
        
        return classInst;
    }
    
    String [] protocolList() {
        /* Return the protocol list. */
        
        return (protocolList == null) ? protocolList = new String[0] : protocolList;
    }
    
    protected GbxMethodHolder [] methodList() {
        /* Return the method list. */
        
        return (methodList == null) ? methodList = new GbxMethodHolder[0] : methodList;
    }
    
    GbxDictionaryHolder [] dictionaryList() {
        /* Return the dictionary list. */
        
        return (dictionaryList == null) ? dictionaryList = new GbxDictionaryHolder[0] : dictionaryList;
    }
    
    void protocol_(String aProtocol) {
   /* Reset the protocol list selection to <aProtocol> while trying
   to preserve the method selection. */
        
        this.protocol_method_(aProtocol, this.selectedMethod());
    }
    
    GbxHolder holderFor_fromList_(GbxHolder aHolder, GbxHolder [] aList) {
   /* Return a holder from <aList> that represents the same
   value as <aHolder>. */
        GbxHolder listHolder;
        
        if (aHolder == null) {
            return null;
        }
        for (int i = 0; i < aList.length; i++) {
            listHolder = aList[i];
            if (listHolder == aHolder) {
                return listHolder;
            }
        }
        for (int i = 0; i < aList.length; i++) {
            listHolder = aList[i];
            if (listHolder.proxy().equals(aHolder.proxy())) {
                return listHolder;
            }
        }
        return null;
    }
    
    void dictionary_classList_class_protocolList_protocol_methodList_method_(GbxDictionaryHolder aDictionaryHolder, GbxClassHolder [] cList, GbxClassHolder aClassHolder, String [] pList, String aProtocol, GbxMethodHolder [] mList, GbxMethodHolder aMethodHolder) {
   /* Reset the browser given the individual selections and lists
   supplied by the arguments. */
        
        GbxDictionaryHolder dictHolder;
        int index;
        
        dictHolder = this.dictionaryHolderFor_(aDictionaryHolder);
        this.changeSelectionTo_from_widget_holders_(dictHolder,
        this.selectedDictionary(), symbolDictionaries, dictionaryList);
        this.classList_class_protocolList_protocol_methodList_method_(cList, aClassHolder, pList, aProtocol, mList, aMethodHolder);
    }
    
    boolean isInstance() {
   /* Return true if the 'instance' switch is selected; false
   otherwise. */
        
        return this.classInst();
    }
    
    void isInstance_(boolean aBoolean) {
   /* Set the value holder for the class/instance switch to
   <aBoolean>. */
        
        classInst = aBoolean;
    }
    
    void dictionaryList_dictionary_classList_class_protocolList_protocol_methodList_method_(GbxDictionaryHolder [] dList, GbxDictionaryHolder aDictionary, GbxClassHolder [] cList, GbxClassHolder aClassHolder, String [] pList, String aProtocol, GbxMethodHolder [] mList, GbxMethodHolder aMethodHolder) {
   /* Reset the browser given the individual selections and lists
   supplied by the arguments. */
        
        dictionaryList = (dList == null) ? this.getDictionaryList() : dList;
        this.updateListWidget_withObjects_(symbolDictionaries, dictionaryList);
        this.dictionary_classList_class_protocolList_protocol_methodList_method_(aDictionary, cList, aClassHolder, pList, aProtocol,mList , aMethodHolder);
    }
    
    
    void class_protocol_(GbxClassHolder aClassHolder, String aProtocol) {
   /* Reset the class list selection to <aClassHolder> and protocol
   list selection to <aProtocol> while trying to preserve the
   method selection. */
        
        this.class_protocol_method_(aClassHolder, aProtocol, this.selectedMethod());
    }
    
    GbxDictionaryHolder dictionaryHolderFor_(GbxDictionaryHolder aHolder) {
   /* Return a dictionary holder from the current list of dictionaries
   that matches <aHolder>. */
        
        return (GbxDictionaryHolder) this.holderFor_fromList_(aHolder, this.dictionaryList()) ;
    }
    
    GbxDictionaryHolder [] getDictionaryList() {
   /* Returns a list of dictionary holders corresponding to the
   dictionaries in the current symbol list. */
        
        return this.dictionaryHolders();
    }
    
    String textForClassOrMethod() {
        
        if (this.selectedClass() == null) {
            return this.textForNewClass();
        }
        if (this.selectedProtocol() == null) {
            if ((textMode == null) || (textMode.equals("classDefinition"))) {
                return this.textForOldClass();
            }
            if (textMode.equals("hierarchy")) {
                return this.textForHierarchy();
            }
            if (textMode.equals("comment")) {
                return this.textForComment();
            }
        }
        if (this.selectedMethod() == null) {
            return this.textForNewMethod();
        }
        return this.textForMethod();
    }
    
    GbjObject selectedClassOrMetaclass() {
   /* Return a proxy for the currently selected GemStone class.
   Take into account the class/instance switch to get the class
   or metaclass. */
        
        return this.isInstance() ? this.selectedNonMetaclass() : this.selectedMetaclass();
    }
    
    public void methodSelected() {
   /* This message is sent from the u/i only to indicate list
   selection from the method list. */
        
        this.resetMethod();
    }
    
    void dictionaryAction() {
        this.dictionarySelected();
    }
    
    void classAction() {
        this.classSelected();
        if (this.selectedClass() != null) {
            this.browseHierarchy();
        }
    }
    
    void protocolAction() {
        this.protocolSelected();
    }
    
    void methodAction() {
        this.methodSelected();
        if (this.selectedMethod() != null) {
            this.browseMethod();
        }
    }
    
    void fileOutDictionary() {
        String aString, fName;
        
        if (this.selectedDictionary() == null) {
            JOptionPane.showMessageDialog(this, GbxConstants.noDictionaryString,"File Out Dictionary",JOptionPane.WARNING_MESSAGE);
            return;
        }
        fName = this.dictionaryName() + ".gs";
        aString = this.fileOutOfDictionary_(this.selectedDictionaryProxy());
        try {
            this.saveTextToFile(aString, "File Out Dictionary", fName);
        } catch (SecurityException ex) {
            this.saveToWorkspace_errorString_(aString, GbxConstants.securityExceptionString);
        }
    }
    
    void saveToWorkspace_errorString_(String fileOutString, String error) {
        GbjWorkSpace workspaceWin=new GbjWorkSpace(session,launcher);
        workspaceWin.setWindowID(launcher.getGlobalWindowID());
        workspaceWin.setTitle("WorkSpace("+error+")."+workspaceWin.getWindowID());
        workspaceWin.workspace.setText(fileOutString);
        workspaceWin.workspace.setCaretPosition(0);
        launcher.addWindowMenu(workspaceWin);
    }
    
    String fileOutOfClass_(GbjObject aClass) {
        String fileOutString;
        
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            fileOutString = this.serverSupport().fileOutOfClass_(aClass);
        } catch (GbjException e) {
            fileOutString = "Error filing out class source";
            this.processError_(e);
        }
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        return fileOutString;
    }
    
    String fileOutOfMethod_inClass_(String selector, GbjObject aClass) {
        String fileOutString;
        
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            fileOutString = this.serverSupport().fileOutOfMethod_inClass_(selector, aClass);
        } catch (GbjException e) {
            fileOutString = "Error filing out method source";
            this.processError_(e);
        }
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        return fileOutString;
    }
    
    String fileOutOfDictionary_(GbjObject aDict) {
        String fileOutString;
        
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            fileOutString = this.serverSupport().fileOutOfDictionary_(aDict);
        } catch (GbjException e) {
            fileOutString = "Error filing out dictionary source";
            this.processError_(e);
        }
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        return fileOutString;
    }
    
    void inspectDictionary() {
        if (this.selectedDictionary() == null) {
            JOptionPane.showMessageDialog(this, GbxConstants.noDictionaryString,"Inspect Dictionary",JOptionPane.WARNING_MESSAGE);
            return;
        }
        GbjInspector anInspector = new GbjInspector(selectedDictionary().proxy(), null,session,launcher);
    }
    
    void addDictionary() {
        /* Prompt the user for a new dictionary name. */
        String aString;
        aString=JOptionPane.showInputDialog(this,GbxConstants.addDictionaryString,"Add Dictionary",JOptionPane.QUESTION_MESSAGE);
        
        String dictName;
        GbxDictionaryHolder aDict, matchingDict = null;
        GbjObject newDict;
        int newIndex;
        
        aString = aString.trim();
        if (aString == null || aString.length() == 0) {
            return;
        }
        dictName = aString;
        //Once added, select the new dictionary so we can begin working there immediately."
        for (int i = 0; i < dictionaryList.length; i++) {
            aDict = dictionaryList[i];
            if (aDict.name().equals(aString)) {
                matchingDict = aDict;
            }
        }
        if (matchingDict != null) {
            JOptionPane.showMessageDialog(this, "Dictionary " + dictName + " already exists.","Add Dictionary",JOptionPane.WARNING_MESSAGE);
        } else {
            newIndex =  symbolDictionaries.getSelectedIndex();
            if (newIndex == -1) {
                newIndex = this.dictionaryList().length + 1;
            } else {
                newIndex = newIndex + 1;
            }
            newDict = this.addDict_at_(dictName, newIndex);
            this.resetDictionaryListSelecting_(new GbxDictionaryHolder(dictName, newDict));
        }
    }
    
    
    void renameDictionary() {
        //Rename the currently selected dictionary to a name supplied by the user."
        String aString;
        if (this.selectedDictionary() == null) {
            JOptionPane.showMessageDialog(this,GbxConstants.noDictionaryString,"Rename Dictionary",JOptionPane.ERROR_MESSAGE);
            return;
        }
        aString = (String)JOptionPane.showInputDialog(this,GbxConstants.renameDictionaryString,"Rename Dictionary",JOptionPane.INFORMATION_MESSAGE,null,null,this.selectedDictionary().name());
        
        boolean result;
        GbxDictionaryHolder dictHolder;
        
        aString = aString.trim();
        if (aString == null || aString.length() == 0) {
            return;
        }
        result = this.renameDictionary_as_(this.selectedDictionary().proxy(), aString);
        if (!result) {
            JOptionPane.showMessageDialog(this, "An object named " + aString + " already exists");
            return;
        }
        dictHolder = new GbxDictionaryHolder(aString, this.selectedDictionaryProxy());
        this.resetDictionaryListSelecting_(dictHolder);
    }
    
    void removeDictionary() {
        //Remove the selected dictionary from the current symbol list."
        
        boolean confirm;
        int size;
        
        if (this.selectedDictionary() == null) {
            JOptionPane.showMessageDialog(this, GbxConstants.noDictionaryString,"Remove Dictionary",JOptionPane.ERROR_MESSAGE);
            return;
        }
        //Make sure they actually want to remove the dictionary - only when there's
        //something in it.  Assume it contains at least a name entry"
        try {
            size = this.serverSupport().remoteSizeOf_(this.selectedDictionary().proxy());
        } catch (GbjException e) {
            this.processError_(e);
            return;
        }
        if (size > 1) {
            if ( JOptionPane.showConfirmDialog(this,GbxConstants.removeDictionaryString,"Remove Dictionary",JOptionPane.YES_NO_OPTION)
            == JOptionPane.YES_OPTION) {
                this.finishRemoveDictionary();
            }
        } else {
            this.removeDictionary_(this.selectedDictionary().proxy());
            this.resetDictionaryListSelecting_(null);
        }
    }
    
    void finishRemoveDictionary() {
        
        //Remove the dictionary from the symbol list, update the view."
        this.removeDictionary_(this.selectedDictionary().proxy());
        this.resetDictionaryListSelecting_(null);
    }
    
    void gotoClass(String aName, GbjObject cls) {
        GbxDictionaryHolder dict;
        
        dict = this.dictionaryHolderFor_(cls);
        if (dict != null) {
            this.dictionary_class_(dict, new GbxClassHolder(aName, cls));
        } else {
            JOptionPane.showMessageDialog(this, "No class named " + aName,"Looking for Class",JOptionPane.ERROR_MESSAGE);
        }
    }
    
    void findClass() {
        //Prompt for a class name and then find and select the given class.
        String className =JOptionPane.showInputDialog(this,GbxConstants.findClassString,"Find Class",JOptionPane.QUESTION_MESSAGE);
        if(className==null)return;
        
        className = className.trim();
        if (className == null || className.length() == 0) {
            return;
        }
        if ((className.indexOf('*') == -1) && (className.indexOf('?') == -1)) {
            this.findClassNamed(className);
            return;
        }
        this.chooseClassNameMatching_dialogString_(className, GbxConstants.findClassString);
        if (listSelected!=null) {
            this.finishFindClass();
        }
    }
    
    void finishFindClass() {
        this.findClassNamed(listSelected);
    }
    
    void findClassNamed(String aClassName) {
        GbjObject destClass = null;
        
        if (aClassName == null) {
            return;
        }
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            destClass = this.serverSupport().classNamed_(aClassName);
        } catch (GbjException e) {
            this.processError_(e);
            setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            return;
        }
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        if (destClass.isNil()) {
            JOptionPane.showMessageDialog(this, "No class named " + aClassName,"Find Class",JOptionPane.ERROR_MESSAGE);
        } else {
            this.gotoClass(aClassName, destClass);
        }
    }
    
    void fileOutClass() {
        String aString, fName;
        
        if (this.selectedClass() == null) {
            JOptionPane.showMessageDialog(this, GbxConstants.noClassString,"File Out Class",JOptionPane.ERROR_MESSAGE);
            return;
        }
        fName = this.selectedClass().name() + ".gs";
        
        aString = this.fileOutOfClass_(this.selectedClass().proxy());
        try {
            this.saveTextToFile(aString, "File Out Class", fName);
        } catch (SecurityException ex) {
            this.saveToWorkspace_errorString_(aString, GbxConstants.securityExceptionString);
        }
    }
    
    public GbjClassBrowser browseClass() {
        /* Open a default GemStone System Browser on <aSession>. */
        
        GbjClassBrowser anApp;
        GbxClassHolder aHolder;
        
        GbxClassHolder [] classList = new GbxClassHolder[1];
        
        if (this.selectedClass() == null) {
            JOptionPane.showMessageDialog(this, GbxConstants.noClassString,"Browse Class",JOptionPane.ERROR_MESSAGE);
            return null;
        }
        anApp = new GbjClassBrowser(session,launcher);
        //new GFrame(anApp, 500, 400);
        //anApp.addToLauncher(this.launcher());
        anApp.session_(this.session());
        anApp.isInstance_(this.isInstance());
        //anApp.initializeUI();
        aHolder = this.selectedClass().defaultCopy();
        classList[0] = aHolder;
        anApp.classList_class_protocolList_protocol_methodList_method_(classList, aHolder, null, this.selectedProtocol(), null, this.selectedMethod());
        anApp.displayWindow();
        return anApp;
    }
    
    public GbjHierarchyBrowser browseHierarchy() {
        /* Open a hierarchy browser on the selected class. */
        
        GbjHierarchyBrowser newBrowser;
        
        if (this.selectedClass() == null) {
            JOptionPane.showMessageDialog(this, GbxConstants.noClassString,"Browse Hierarchy",JOptionPane.ERROR_MESSAGE);
            return null;
        }
        newBrowser = new GbjHierarchyBrowser(session,launcher);
        //new GFrame(newBrowser, 500, 360);
        //newBrowser.addToLauncher(this.launcher());
        newBrowser.myClass_(this.selectedClass());
        newBrowser.isInstance_(this.isInstance());
        newBrowser.session_(this.session());
        //newBrowser.initializeUI();
        newBrowser.classList_class_protocolList_protocol_methodList_method_(null, this.selectedClass(), null, this.selectedProtocol(), null, this.selectedMethod());
        //newBrowser.open();
        newBrowser.displayWindow();
        return newBrowser;
    }
    
    public GbjClassVersionBrowser browseVersions() {
        /* Open a class version browser on the selected class.*/
        
        GbjClassVersionBrowser newBrowser;
        
        if (this.selectedClass() == null) {
            JOptionPane.showMessageDialog(this, GbxConstants.noClassString,"Browse Versions",JOptionPane.ERROR_MESSAGE);
            return null;
        }
        newBrowser = new GbjClassVersionBrowser(session,launcher);
        //new GFrame(newBrowser, 500, 360);
        //newBrowser.addToLauncher(this.launcher());
        newBrowser.isInstance_(this.isInstance());
        //newBrowser.session_(this.session());
        newBrowser.classHistory_(this.classHistoryFor_(this.selectedClass().proxy()));
        //newBrowser.initializeUI();
        newBrowser.classList_class_protocolList_protocol_methodList_method_(null, this.selectedClass(), null, this.selectedProtocol(), null, this.selectedMethod());
        newBrowser.displayWindow();
        return newBrowser;
    }
    
    void showHierarchy() {
        /* Switch to a mode that displays the class hierarchy. */
        
        if (this.selectedClass() == null) {
            JOptionPane.showMessageDialog(this, GbxConstants.noClassString,"Show Hierarchy",JOptionPane.ERROR_MESSAGE);
            return;
        }
        this.textMode_("hierarchy");
        this.protocol_(null);
    }
    
    void showDefinition() {
        /* Switch to a mode that displays the class definition. */
        
        if (this.selectedClass() == null) {
            JOptionPane.showMessageDialog(this, GbxConstants.noClassString,"Show Definition",JOptionPane.ERROR_MESSAGE);
            return;
        }
        this.textMode_("classDefinition");
        this.protocol_(null);
    }
    
    void showComment() {
        /* Switch to a mode that displays the class comment.*/
        
        if (this.selectedClass() == null) {
            JOptionPane.showMessageDialog(this, GbxConstants.noClassString,"Show Comment",JOptionPane.ERROR_MESSAGE);
            return;
        }
        this.textMode_("comment");
        this.protocol_(null);
    }
    
    void moveClass() {
        /* Move the current class to a different symbol dictionary. */
        
        GbxDictionaryHolder aDictHolder;
        String aKey;
        
        if (this.selectedClass() == null) {
            JOptionPane.showMessageDialog(this, GbxConstants.noClassString,"Move Class",JOptionPane.ERROR_MESSAGE);
            return;
        }
        aDictHolder = this.selectedDictionaryForClass_(this.selectedNonMetaclass());
        if (aDictHolder == null) {
            JOptionPane.showMessageDialog(this, "Unable to determine dictionary containing class","Move Class",JOptionPane.ERROR_MESSAGE);
            return;
        }
        /* Prompt for a dictionary to move to */
        this.selectDictionary();
        if (listSelected!=null) {
            this.finishMoveClass();
        }
    }
    
    void finishMoveClass() {
        GbjObject currentDict;
        GbjObject newDict;
        GbxDictionaryHolder aDictHolder;
        GbjObject aKey;
        GbjObject aClass;
        
        newDict = (GbjObject) this.finishSelectDictionary();
        aDictHolder = this.selectedDictionaryForClass_(this.selectedNonMetaclass());
        if (aDictHolder == null) {
            return;
        }
        currentDict = aDictHolder.proxy();
        if ((newDict == null) || (newDict.equals(currentDict))) {
            return;
        }
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        aClass = this.selectedNonMetaclass();
        try {
            this.serverSupport().moveClass_fromDict_toDict_(aClass, currentDict, newDict);
        } catch (GbjException e) {
            this.processError_(e);
        }
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        this.resetClassOrganizer();
        this.postMoveClass();
    }
    
    void postMoveClass() {
        this.resetDictionary();
    }
    
    void postRemoveClass() {
   /* System and dictionary browsers should reset the current selection and class list when a
   class is removed.  Subclasses may take different action. */
        
        this.resetDictionary();
    }
    
    void selectDictionary() {
        /* Prompt with a list of available GemStone symbol list dictionaries */
        
        String [] names;
        
        try {
            names = this.serverSupport().dictionaryNames();
        } catch (GbjException e) {
            this.processError_(e);
            return;
        }
        GbxListDialog listDialog=new GbxListDialog("Move Class", GbxConstants.moveClassString, names);
        listSelected=listDialog.result();
    }
    
    GbjObject finishSelectDictionary() {
        String dictName;
        GbjObject odict;
        
        dictName = listSelected;
        if (dictName == null) {
            return null;
        }
        
        /* Search for association corresponding to this classname */
        try {
            odict = this.serverSupport().evaluate_inContext_names_values_printing_(dictName, null, null, null, false);
            if ((odict != null) && (this.serverSupport().isDictionary_(odict))) {
                return odict;
            } else {
                
                JOptionPane.showMessageDialog(this, "No GemStone Dictionary " + dictName,"Move Class",JOptionPane.ERROR_MESSAGE);
                return null;
            }
        } catch (GbjException e) {
            this.processError_(e);
        }
        return null;
    }
    
    void removeClass() {
        /* Remove the selected class from its dictionary. */
        
        if (this.selectedClass() == null) {
            JOptionPane.showMessageDialog(this, GbxConstants.noClassString,"Remove Class",JOptionPane.ERROR_MESSAGE);
            return;
        }
        if(JOptionPane.showConfirmDialog(this,GbxConstants.removeClassString,"Remove Class",JOptionPane.YES_NO_OPTION)
        ==JOptionPane.YES_OPTION) {
            this.finishRemoveClass();
        }
    }
    
    GbxDictionaryHolder selectedDictionaryForClass_(GbjObject aClass) {
        try {
            if (this.serverSupport().collection_includes_(this.selectedDictionaryProxy(), aClass)) {
                return this.selectedDictionary();
            } else {
                return null;
            }
        } catch (GbjException e) {
            this.processError_(e);
        }
        return null;
    }
    
    void finishRemoveClass() {
        GbxDictionaryHolder itsDict;
        boolean confirm;
        GbjObject aKey;
        
        itsDict = this.selectedDictionaryForClass_(this.selectedNonMetaclass());
        if (itsDict == null) {
            JOptionPane.showMessageDialog(this, "Unable to determine dictionary containing class","Remove Class",JOptionPane.ERROR_MESSAGE);
            return;
        }
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            this.serverSupport().removeClass_fromDict_(this.selectedNonMetaclass(), itsDict.proxy());
        } catch (GbjException e) {
            this.processError_(e);
            return;
        }
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        this.resetClassOrganizer();
        this.postRemoveClass();
    }
    
    void addProtocol() {
        /* Add a new protocol to the currently selected class. */
        String aProtocol;
        
        if (this.selectedClass() == null) {
            JOptionPane.showMessageDialog(this, GbxConstants.noClassString,"Add Protocol",JOptionPane.ERROR_MESSAGE);
            return;
        }
        aProtocol = LastProtocol == null ? "" : LastProtocol;
        String newProtocol=(String)JOptionPane.showInputDialog(this,GbxConstants.addProtocolString,"Add Protocol",
        JOptionPane.QUESTION_MESSAGE,null,null,aProtocol);
        if (newProtocol==null)return;
        
        newProtocol = newProtocol.trim();
        if (newProtocol == null || newProtocol.length() == 0) {
            return;
        }
        /* If the new category already exists, then show an error. */
        if (this.protocolExists_(newProtocol)) {
            JOptionPane.showMessageDialog(this, "Protocol " + newProtocol + " already exists.","Add Protocol",JOptionPane.ERROR_MESSAGE);
            return;
        }
        
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            this.serverSupport().addProtocol_toClass_(newProtocol, this.selectedClassOrMetaclass());
        } catch (GbjException e) {
            this.processError_(e);
        }
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        this.resetClassSelectingProtocol_(newProtocol);
    }
    
    void renameProtocol() {
        /* Rename the currently selected protocol to a name suppled by the user. */
        if (this.selectedProtocol() == null) {
            JOptionPane.showMessageDialog(this,GbxConstants.noProtocolString,"Rename Protocol",JOptionPane.ERROR_MESSAGE);
            return;
        }
        String newName = (String)JOptionPane.showInputDialog(this,GbxConstants.renameProtocolString,"Rename Protocol",
        JOptionPane.QUESTION_MESSAGE,null,null,this.selectedProtocol());
        if(newName==null)return;
        
        String oldName;
        
        oldName = this.selectedProtocol();
        newName = newName.trim();
        if ((newName.length() == 0) || (newName.equals(oldName))) {
            return;
        }
        String [] aList = this.getProtocolListToLevel_(-1);
        if (this.protocolExists_inList_(newName, aList)) {
            /* Make sure that the new category doesn't already exist. */
            JOptionPane.showMessageDialog(this,"There is already a category named " + newName,"Rename Protocol",JOptionPane.ERROR_MESSAGE);
            return;
        }
        if (!this.protocolExists_inList_(oldName, aList)) {
            /* Make sure that the old category does already exist. */
            JOptionPane.showMessageDialog(this,"There is no category named " + oldName,"Rename Protocol",JOptionPane.ERROR_MESSAGE);
            this.resetClass();
            return;
        }
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            this.serverSupport().renameProtocol_to_inClass_(oldName, newName, this.selectedClassOrMetaclass());
        } catch (GbjException e) {
            this.processError_(e);
            return;
        }
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        this.resetClass();
    }
    
    void removeProtocol() {
        /* Remove the currently selected protocol from the selected class. */
        
        if (this.selectedProtocol() == null) {
            JOptionPane.showMessageDialog(this,GbxConstants.noProtocolString,"Remove Protocol",JOptionPane.ERROR_MESSAGE);
            return;
        }
   /* If there are methods in this category, then make sure the user really
    wants to do this. */
        if (this.getMethodList().length == 0) {
            this.finishRemoveProtocol();
        } else {
            if(JOptionPane.showConfirmDialog(this,GbxConstants.removeProtocolString,"Remove Protocol",JOptionPane.YES_NO_OPTION)
            ==JOptionPane.YES_OPTION)
                this.finishRemoveProtocol();
        }
    }
    
    void finishRemoveProtocol() {
        /* Remove the category and all of its methods from GemStone. */
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            if (this.protocolExists_(this.selectedProtocol())) {
                this.serverSupport().removeProtocol_fromClass_(this.selectedProtocol(), this.selectedClassOrMetaclass());
            } else {
                
                JOptionPane.showMessageDialog(this,"Category no longer exists","Remove Protocol",JOptionPane.ERROR_MESSAGE);
            }
        } catch (GbjException e) {
            this.processError_(e);
        }
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        this.resetClass();
    }
    
    void findMethod() {
        /* Show a menu of the methods implemented by this class.  Select the chosen one. */
        String [] selectorCollection;
        
        if (this.selectedClass() == null) {
            JOptionPane.showMessageDialog(this,GbxConstants.noClassString,"Find Method",JOptionPane.WARNING_MESSAGE);
            return;
        }
        try {
            selectorCollection = this.serverSupport().selectorsForClass_(this.selectedClassOrMetaclass());
            if (selectorCollection.length == 0) {
                JOptionPane.showMessageDialog(this,"No methods","Find Method",JOptionPane.INFORMATION_MESSAGE);
                return;
            }
            GbxListDialog listDialog=new GbxListDialog("Find Method", GbxConstants.findMethodString, selectorCollection);
            listSelected=listDialog.result();
            if(listSelected!=null)finishFindMethod();
        } catch (GbjException e) {
            this.processError_(e);
        }
    }
    
    void finishFindMethod() {
        String chosenSelector;
        String [] selectorCollection;
        GbxMethodHolder mthHolder;
        
        chosenSelector = listSelected;
        mthHolder = new GbxMethodHolder(chosenSelector, null);
        if (chosenSelector != null) {
            this.protocol_method_(this.findProtocolFor_(chosenSelector), mthHolder);
        }
    }
    
    String findProtocolFor_(String aSelector) {
        /* Find the protocol in the currently selected class of <aSelector>. */
        
        try {
            return this.serverSupport().protocolForSelector_inClass_(aSelector, this.selectedClassOrMetaclass());
        } catch (GbjException e) {
            this.processError_(e);
        }
        return null;
    }
    
    void fileOutMethod() {
        String aString, fName;
        
        if (this.selectedMethod() == null || this.selectedClass() == null) {
            JOptionPane.showMessageDialog(this,GbxConstants.noMethodString,"File Out Method",JOptionPane.ERROR_MESSAGE);
            return;
        }
        fName = new String(this.methodClass().name()).replace(' ', '_') +
        "-" +
        new String(this.selectedMethod().name()).replace(':', '_') +
        ".gs";
        aString = this.fileOutOfMethod_inClass_(this.selectedMethod().name(), this.selectedClassOrMetaclass());
        try {
            this.saveTextToFile(aString, "File Out Method", fName);
        } catch (SecurityException ex) {
            this.saveToWorkspace_errorString_(aString, GbxConstants.securityExceptionString);
        }
    }
    
    void browseMethod() {
        /* Open a method browser on the currently selected method. */
        GbjMethodBrowser newBrowser;
        GbxMethodHolder aHolder;
        
        if (this.selectedMethod() == null) {
            JOptionPane.showMessageDialog(this,GbxConstants.noMethodString,"Browse Method",JOptionPane.WARNING_MESSAGE);
            return;
        }
        GbxClassHolder [] cList = new GbxClassHolder[1];
        String [] pList = new String[1];
        GbxMethodHolder [] mList = new GbxMethodHolder[1];
        
        newBrowser = new GbjMethodBrowser(session,launcher);
        newBrowser.session_(session);
        newBrowser.isInstance_(this.isInstance());
        cList[0] = this.methodClass();
        pList[0] = this.methodProtocol();
        aHolder = this.selectedMethod().defaultCopy();
        mList[0] = aHolder;
        newBrowser.classList_class_protocolList_protocol_methodList_method_(cList, this.methodClass(), pList, this.methodProtocol(), mList, aHolder);
        newBrowser.setWindowID(launcher.getGlobalWindowID());
        newBrowser.setTitle("GBJ Method Browser: "+mList[0].displayString());
        launcher.registerWindow(newBrowser);
        launcher.addWindowMenu(newBrowser);
        newBrowser.displayWindow();
    }
    
    void browseSenders() {
        /* Browse all implementors of methods that send the currently selected message. */
        if (this.selectedMethod() == null) {
            JOptionPane.showMessageDialog(this,GbxConstants.noMethodString,"Browse Senders",JOptionPane.ERROR_MESSAGE);
            return;
        }
        browseAllCallsOn_inSession_(this, this.selectedMethod().name(), session, launcher);
    }
    
    void browseImplementors() {
        if (this.selectedMethod() == null) {
            JOptionPane.showMessageDialog(this,GbxConstants.noMethodString,"Browse Implementors",JOptionPane.ERROR_MESSAGE);
            return;
        }
        browseAllImplementorsOf_inSession_(this, this.selectedMethod().name(), session, launcher);
    }
    
    void browseAllImplementorsOf_inSession_(GbxTool aTool, String selector, GbjSession aSession, GbjLauncher aLauncher) {
   /* Open a method list browser on each method that implements the
   message whose selector is the argument, selector */
        
        GbxMethodHolder [] methods;
        if(session==null)session=aSession;
        if(launcher==null)launcher=aLauncher;
        
        aTool.setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            methods = aTool.serverSupport().methodHoldersForImplementorsOf_(selector);
        } catch (GbjException e) {
            aTool.processError_(e);
            methods = new GbxMethodHolder[0];
            aTool.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            return;
        }
        aTool.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        if (methods.length == 0) {
            JOptionPane.showMessageDialog(aTool,"Nobody","Implementors of",JOptionPane.INFORMATION_MESSAGE);
            return;
        }
        
        GbjMethodListBrowser mlb=new GbjMethodListBrowser(session,launcher);
        mlb.openListBrowserOn_label_session_launcher_(methods,
        "GBJ Implementors: " + selector, aSession, aLauncher);
    }
    
    void browseAllCallsOn_inSession_(GbxTool aTool, String selector, GbjSession aSession, GbjLauncher aLauncher) {
   /* Open a method list browser on each method that sends the
   message whose selector is the argument, selector */
        
        GbxMethodHolder [] methods;
        
        if(session==null)session=aSession;
        if(launcher==null)launcher=aLauncher;
        
        aTool.setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            methods = aTool.serverSupport().methodHoldersForSendersOf_(selector);
        } catch (GbjException e) {
            aTool.processError_(e);
            methods = new GbxMethodHolder[0];
            aTool.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            return;
        }
        aTool.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        if (methods.length == 0) {
            JOptionPane.showMessageDialog(aTool,"Nobody");
            return;
        }
        GbjMethodListBrowser mlb=new GbjMethodListBrowser(session,launcher);
        mlb.openListBrowserOn_label_initialSelection_session_launcher_(methods,
        "GBJ Senders: " + selector, selector, aSession, aLauncher);
    }
    
    protected void browseAllMethodsWithSubstring_inSession_(GbxTool aTool, String substring, GbjSession aSession, GbjLauncher aLauncher) {
   /* Open a method list browser on each method that
   has source code containing the substring <substring> */
        
        GbxMethodHolder [] methods;
        
        if(session==null)session=aSession;
        if(launcher==null)launcher=aLauncher;
        
        aTool.setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            methods = aTool.serverSupport().methodHoldersForSubstring_(substring);
        } catch (GbjException e) {
            aTool.processError_(e);
            methods = new GbxMethodHolder[0];
            aTool.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            return;
        }
        aTool.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        if (methods.length == 0) {
            JOptionPane.showMessageDialog(aTool,"Nobody");
            return;
        }
        GbjMethodListBrowser mlb=new GbjMethodListBrowser(session,launcher);
        mlb.openListBrowserOn_label_initialSelection_session_launcher_(methods,
        "GBJ Method with Substring: " + substring, substring, aSession, aLauncher);
    }
    
    static void browseAllMethodsReferencing_inSession_(GbxTool aTool, String aSymbol, GbjSession aSession, GbjLauncher aLauncher) {
   /* Open a method list browser on each method that
   has source code that references the symbol <aSymbol> */
        
        GbxMethodHolder [] methods;
        
        aTool.setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            methods = aTool.serverSupport().methodHoldersForReferencesTo_(aSymbol);
        } catch (GbjException e) {
            aTool.processError_(e);
            methods = new GbxMethodHolder[0];
            aTool.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            return;
        }
        aTool.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        if (methods.length == 0) {
            JOptionPane.showMessageDialog(aTool,"Nobody");
            return;
        }
        new GbjMethodListBrowser(aSession,aLauncher).openListBrowserOn_label_initialSelection_session_launcher_(methods,
        "GBJ Method with References to: " + aSymbol, aSymbol, aSession, aLauncher);
    }
    
    void browseMessages() {
        /* Browse all implementors of a message sent from the currently selected method. */
        
        GbjCollection selectorsProxy;
        String [] selectorStrings;
        
        if (this.selectedMethod() == null) {
            JOptionPane.showMessageDialog(this, GbxConstants.noMethodString,"Browse Messages",JOptionPane.ERROR_MESSAGE);
            return;
        }
        try {
            selectorStrings = this.serverSupport().messagesInMethod_inClass_(this.selectedMethod().name(), this.methodClassProxy());
            if (selectorStrings.length == 0) {
                JOptionPane.showMessageDialog(this, "No message","Browse Messages",JOptionPane.ERROR_MESSAGE);
                return;
            }
            GbxListDialog listDialog=new GbxListDialog("Browse Messages", GbxConstants.messagesString, selectorStrings);
            listSelected=listDialog.result();
            if(listSelected!=null)finishBrowseMessages();
        } catch (GbjException e) {
            this.processError_(e);
        }
    }
    
    void finishBrowseMessages() {
        String selector;
        
        selector = listSelected;
        if (selector != null) {
            browseAllImplementorsOf_inSession_(this, selector, session, launcher);
        }
    }
    
    void moveMethod() {
        /* Move a method to a new protocol and refresh the browser. */
        
        if (this.selectedMethod() == null) {
            JOptionPane.showMessageDialog(this, GbxConstants.noMethodString,"Move Method",JOptionPane.ERROR_MESSAGE);
            return;
        }
        listSelected=(String)JOptionPane.showInputDialog(this,GbxConstants.moveMethodString,"Move Method",JOptionPane.QUESTION_MESSAGE,null,null,MethodMoveProtocol);
        if (listSelected!=null) {
            this.finishMoveMethod();
        }
    }
    
    void finishMoveMethod() {
        String newProtocol;
        GbjObject thisClass;
        String oldProtocol;
        
        newProtocol = listSelected.trim();
        if (newProtocol == null || newProtocol.length() == 0) {
            return;
        }
        oldProtocol = this.methodProtocol();
        MethodMoveProtocol = newProtocol;
        /* Get the current class object and category list. */
        thisClass = this.methodClassProxy();
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            if (this.protocolExists_(newProtocol)) {
                if (newProtocol.equals(oldProtocol)) {
                    setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
                    return;
                }
            } else {
                this.serverSupport().addProtocol_toClass_(newProtocol, thisClass);
            }
            this.serverSupport().moveMethod_to_inClass_(this.selectedMethod().name(), newProtocol, thisClass);
        } catch (GbjException e) {
            this.processError_(e);
        }
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        this.class_protocol_method_(this.selectedClass(), this.selectedProtocol(), this.selectedMethod());
    }
    
    void removeMethod() {
        /* Remove the currently selected method from the currently selected class. */
        
        if (this.selectedMethod() == null) {
            JOptionPane.showMessageDialog(this, GbxConstants.noMethodString,"Remove Method",JOptionPane.ERROR_MESSAGE);
            return;
        }
        if(JOptionPane.showConfirmDialog(this,GbxConstants.removeMethodString,"Remove Method",JOptionPane.YES_NO_OPTION)
        ==JOptionPane.YES_OPTION)
            this.finishRemoveMethod();
    }
    
    protected void finishRemoveMethod() {
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            this.serverSupport().removeMethod_fromClass_(this.selectedMethod().name(), this.methodClassProxy());
            this.protocol_(this.selectedProtocol());
        } catch (GbjException e) {
            this.processError_(e);
        }
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
    }
    
    void cancelText() {
        this.resetText();
    }
    
    void acceptText() {
        this.acceptTextShowingErrors(workspace.getText());
    }
    
    void acceptTextShowingErrors(String aString) {
        this.acceptText(aString);
    }
    
    boolean acceptText(String aString) {
        return (this.selectedDictionary() == null)
        ? false
        : this.acceptClassOrMethodText(aString);
    }
    
    void showCompilerErrorArray(Vector v) {
        String errText;
        int srcIdx;
        
        errText = (String) v.elementAt(1) + "->";
        srcIdx = ((Integer) v.elementAt(2)).intValue() - 1;
        workspace.insert(errText, srcIdx);
        //textView.requestFocus();
        workspace.select(srcIdx, srcIdx+errText.length());
    }
    
    void showWarningMessage(String aString) {
        JOptionPane.showMessageDialog(this,aString);
    }
    
    
    void postAcceptForClass_(GbxClassHolder aClass) {
        /* A system browser should reset the selected dictionary and its list of classes. */
        /* Subclasses may override to do other things. */
        
        this.resetDictionarySelectingClass_(aClass);
    }
    
    String textForHierarchy() {
        /* Return the text for the class hierarchy of the currently selected class. */
        
        GbxClassHolder [] list;
        String result;
        GbxClassHolder aHolder;
        
        if (this.selectedClass() == null) {
            return new String();
        }
        list = this.classHierarchyHoldersFor_(this.selectedNonMetaclass());
        result = new String();
        for (int i = 0; i < list.length; i++) {
            aHolder = list[i];
            result = result + aHolder.displayString() + aHolder.ivString() + "\n";
        }
        return result;
    }
    
    String textForComment() {
        /* Return the text for the class comment of the currently selected class. */
        
        GbjObject description;
        String comment = "";
        
        if (this.selectedClass() == null) {
            return comment;
        }
        try {
            comment = this.serverSupport().commentForClass_(this.selectedNonMetaclass());
        } catch (GbjException e) {
            this.processError_(e);
        }
        return comment;
    }
    
    GbxClassHolder [] classHoldersFor_(GbjObject anObject) {
        GbxClassHolder [] holders;
        
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            holders = this.serverSupport().classHoldersFor_(anObject);
        } catch (GbjException e) {
            this.processError_(e);
            holders = new GbxClassHolder[0];
        }
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        return holders;
    }
    
    GbxDictionaryHolder [] dictionaryHolders() {
        GbxDictionaryHolder [] holders;
        
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            holders = this.serverSupport().dictionaryHolders();
        } catch (GbjException e) {
            this.processError_(e);
            holders = new GbxDictionaryHolder[0];
        }
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        return holders;
    }
    
    GbxMethodHolder [] methodHoldersFor_inProtocol_(GbjObject anObject, String aProtocol) {
        GbxMethodHolder [] holders;
        
        if (aProtocol == null) {
            return new GbxMethodHolder[0];
        }
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            holders = this.serverSupport().methodHoldersFor_inProtocol_toLevel_(anObject, aProtocol, browseLevel);
        } catch (GbjException e) {
            this.processError_(e);
            holders = new GbxMethodHolder[0];
        }
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        return holders;
    }
    
    String [] protocolHoldersFor_toLevel_(GbjObject anObject, int aLevel) {
        String [] holders;
        
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            holders = this.serverSupport().protocolHoldersFor_toLevel_(anObject, aLevel);
        } catch (GbjException e) {
            this.processError_(e);
            holders = new String[0];
        }
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        return holders;
    }
    
    GbxDictionaryHolder dictionaryHolderFor_(GbjObject anObject) {
        //Return the symbol list dictionary for <anObject>."
        
        try {
            return this.serverSupport().dictionaryHolderFor_(anObject);
        } catch (GbjException e) {
            this.processError_(e);
        }
        return null;
    }
    
    GbjObject addDict_at_(String aString, int index) {
        GbjObject newDict = null;
        
        //This method actually performs the work of adding a dictionary to the user's symbol list."
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            newDict = this.serverSupport().addDict_at_(aString, index);
        } catch (GbjException e) {
            this.processError_(e);
        }
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        //Return the new GemStone SymbolDictionary object."
        return newDict;
    }
    
    boolean renameDictionary_as_(GbjObject aDictionary, String aString) {
        boolean result = false;
        
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            result =  this.serverSupport().renameDictionary_as_(aDictionary, aString);
        } catch (GbjException e) {
            this.processError_(e);
        }
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        return result;
    }
    
    void removeDictionary_(GbjObject aProxy) {
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            this.serverSupport().removeDictionary_(aProxy);
        } catch (GbjException e) {
            this.processError_(e);
        }
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
    }
    
    
    Vector compile_classified_class_(String source, String aProtocol, GbjObject aClass) {
        Vector aVector;
        
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            aVector = this.serverSupport().compile_classified_class_(source, aProtocol, aClass);
        } catch (GbjException e) {
            this.processError_(e);
            aVector = new Vector();
        }
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        return aVector;
    }
    
    GbxClassHolder [] classHierarchyHoldersFor_(GbjObject anObject) {
        GbxClassHolder [] holders;
        
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            holders = this.serverSupport().classHierarchyHoldersFor_(anObject);
        } catch (GbjException e) {
            this.processError_(e);
            holders = new GbxClassHolder[0];
        }
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        return holders;
    }
    
    GbjObject classHistoryFor_(GbjObject aClass) {
        GbjObject hist = null;
        try {
            hist = this.serverSupport().classHistoryFor_(aClass);
        } catch (GbjException e) {
            this.processError_(e);
        }
        return hist;
    }
    
    GbxDictionaryHolder dictionaryForClass_(GbjObject aClassProxy) {
        /* Return the symbol list dictionary for <aClassProxy>. */
        
        try {
            return this.serverSupport().dictionaryForClass_(aClassProxy);
        } catch (GbjException e) {
            this.processError_(e);
            return null;
        }
    }
    
    void showClassTemplate() {
        template=true;
        classes.clearSelection();
        symbolDictionaries.requestFocus();
        this.class_(null);
    }
    
    void showMethodTemplate() {
        template=true;
        methods.clearSelection();
        protocol.requestFocus();
        this.method_(null);
    }
    
    public GbjObject contextObject() {
        return this.selectedNonMetaclass();
    }
    
    Object [] removeMethodSelectionFromList_andArray_(JList aList, GbxMethodHolder [] objects) {
        GbxMethodHolder [] newObjects;
        
        int index = aList.getSelectedIndex();
        if (index != -1) {
            ListSelectionModel listselect=aList.getSelectionModel();
            listselect.clearSelection();
            aList.remove(index);
            newObjects = new GbxMethodHolder[objects.length - 1];
            for (int i = 0; i < index; i++) {
                newObjects[i] = objects[i];
            }
            for (int i = index; i < objects.length - 1; i++) {
                newObjects[i] = objects[i + 1];
            }
            return newObjects;
        } else {
            return objects;
        }
    }
    
    void browseInstVarRefs() {
        String [] names;
        
        if (this.selectedClass() == null) {
            JOptionPane.showMessageDialog(this,GbxConstants.noClassString,"Inst Var Refs",JOptionPane.WARNING_MESSAGE);
            return;
        }
        try {
            names = this.serverSupport().instVarNamesInClass_(this.selectedClassOrMetaclass());
        } catch (GbjException e) {
            this.processError_(e);
            return;
        }
        if (names.length == 0) {
            JOptionPane.showMessageDialog(this,"No instance variables","Inst Var Refs",JOptionPane.WARNING_MESSAGE);
        } else {
            GbxListDialog listDialog=new GbxListDialog("Inst Var Refs", GbxConstants.instVarRefsString, names);
            listSelected=listDialog.result();
            if (listSelected!=null) {
                this.finishBrowseInstVarRefs();
            }
        }
    }
    
    void browseClassVarRefs() {
        String [] names;
        
        if (this.selectedClass() == null) {
            JOptionPane.showMessageDialog(this,GbxConstants.noClassString,"Class Var Refs",JOptionPane.WARNING_MESSAGE);
            return;
        }
        try {
            names = this.serverSupport().classVarNamesInClass_(this.selectedClass().proxy());
        } catch (GbjException e) {
            this.processError_(e);
            return;
        }
        if (names.length == 0) {
            JOptionPane.showMessageDialog(this,"No class variables","Class Var Refs",JOptionPane.WARNING_MESSAGE);
        } else {
            GbxListDialog listDialog=new GbxListDialog("Class Var Refs", GbxConstants.classVarRefsString, names);
            listSelected=listDialog.result();
            if (listSelected!=null) {
                this.finishBrowseClassVarRefs();
            }
        }
    }
    
    void finishBrowseInstVarRefs() {
        GbxMethodHolder [] methods;
        String ivName;
        
        ivName = listSelected;
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            methods = this.serverSupport().methodHoldersForRefsToInstVar_inClass_(ivName, this.selectedClassOrMetaclass());
        } catch (GbjException e) {
            this.processError_(e);
            methods = new GbxMethodHolder[0];
            setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            return;
        }
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        if (methods.length == 0) {
            JOptionPane.showMessageDialog(this,"Nobody");
            return;
        }
        GbjMethodListBrowser mlb=new GbjMethodListBrowser(session,launcher);
        mlb.openListBrowserOn_label_session_launcher_(methods,
        "GBJ References to Inst Var " + ivName, session, launcher);
    }
    
    void finishBrowseClassVarRefs() {
        GbxMethodHolder [] methods;
        String cvName;
        
        cvName = listSelected;
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            methods = this.serverSupport().methodHoldersForRefsToClassVar_inClass_(cvName, this.selectedClass().proxy());
        } catch (GbjException e) {
            this.processError_(e);
            methods = new GbxMethodHolder[0];
            setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            return;
        }
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        if (methods.length == 0) {
            JOptionPane.showMessageDialog(this,"Nobody");
            return;
        }
        GbjMethodListBrowser mlb=new GbjMethodListBrowser(session,launcher);
        mlb.openListBrowserOn_label_session_launcher_(methods,
        "GBJ References to Class Var " + cvName , session, launcher);
    }
    
    void browseClassRefs() {
        GbxMethodHolder [] methods;
        
        if (this.selectedClass() == null) {
            JOptionPane.showMessageDialog(this,GbxConstants.noClassString,"Class References",JOptionPane.WARNING_MESSAGE);
            return;
        }
        
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        try {
            methods = this.serverSupport().methodHoldersForRefsToClass_(this.selectedClass().proxy());
        } catch (GbjException e) {
            this.processError_(e);
            methods = new GbxMethodHolder[0];
            setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            return;
        }
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        if (methods.length == 0) {
            JOptionPane.showMessageDialog(this,"Nobody");
            return;
        }
        GbjMethodListBrowser mlb=new GbjMethodListBrowser(session,launcher);
        mlb.openListBrowserOn_label_session_launcher_(methods,
        "GBJ References to Class: " + this.selectedClass().name(), session, launcher);
    }
    
    GbxClassHolder methodClass() {
        return new GbxClassHolder(this.methodClassName(), this.methodClassProxy());
    }
    
    String methodClassName() {
        return this.selectedMethod().remoteClassName();
    }
    
    String methodProtocol() {
        if (this.selectedMethod() == null) {
            return this.selectedProtocol();
        } else {
            return this.selectedMethod().protocol();
        }
    }
    
    void browseClassOnly() {
        browseLevel = -1;
        this.resetClass();
    }
    
    
    public void setBreak() {
        if (this.selectedMethod() == null) {
            JOptionPane.showMessageDialog(this,GbxConstants.noMethodString,"Set Break",JOptionPane.WARNING_MESSAGE);
            return;
        }
        try {
            this.serverSupport().setBreakIn_at_(this.selectedMethod().proxy(), workspace.getSelectionStart());
        } catch (GbjException e) {
            this.processError_(e);
        }
    }
    
    public void changeSelectionTo_from_widget_holders_(Object newHolder, Object old, JList
    widget, Object [] holders) {
        int index;
        
        if (widget != null) {
            if (!(old == newHolder)) {
                // If newHolder is null and there is a selection, deselect
                if (newHolder == null) {
                    index  = widget.getSelectedIndex();
                    if (index > -1) {
                        widget.clearSelection();
                    }
                } else {
                    index = this.indexOf_inList_(newHolder, holders);
                    if (index > -1) {
                        widget.setSelectedIndex(index);
                        widget.ensureIndexIsVisible( index);
                    }
                }
            }
        }
    }
    
    public void mousePressed(java.awt.event.MouseEvent mouseEvent) {
        super.mousePressed(mouseEvent);
    }
    
    public void mouseClicked(java.awt.event.MouseEvent mouseEvent) {
        Object source=mouseEvent.getSource();
        if(source== symbolDictionaries){
            if(mouseEvent.getClickCount()==1)
                dictionaryAction();
            else if(mouseEvent.getClickCount()==2){
                dictionaryAction();
                inspectDictionary();
            }
        }
        else
            if(source==classes){
                if(mouseEvent.getClickCount()==1)
                    classSelected();
                else if(mouseEvent.getClickCount()==2)
                    classAction();
            }else if(source==protocol){
                protocolAction();
            }else if(source==methods){
                if(mouseEvent.getClickCount()==1)
                    methodSelected();
                else if(mouseEvent.getClickCount()==2)
                    methodAction();
            }
    }
    
    protected void checkPopup(java.awt.event.MouseEvent e) {
        if (e.isPopupTrigger()) {
            Object comp=e.getComponent();
            selectedComponent=e.getComponent();
            if(comp==symbolDictionaries){
                dictPopup.show(e.getComponent(),e.getX(),e.getY());
            }else if(comp == classes){
                classPopup.show(e.getComponent(),e.getX(),e.getY());
            }else if(comp ==protocol){
                protoPopup.show(e.getComponent(),e.getX(),e.getY());
            }else if(comp==methods){
                methodPopup.show(e.getComponent(),e.getX(),e.getY());
            }else super.checkPopup(e);
            
        }
        
    }
    protected void initPopupMenu() {
        JMenuItem temp;
        stdPopUp=new JPopupMenu();
        try{
            temp=stdPopUp.add(getActionByName(DefaultEditorKit.cutAction));
            temp.setName("Cut Popup MenuItem");
            temp=stdPopUp.add(getActionByName(DefaultEditorKit.copyAction));
            temp.setName("Copy Popup MenuItem");
            temp=stdPopUp.add(getActionByName(DefaultEditorKit.pasteAction));
            temp.setName("Paste Popup MenuItem");
            stdPopUp.add(new JSeparator());
            temp=stdPopUp.add(getActionByName(DefaultEditorKit.selectAllAction));
            temp.setName("Select All Popup MenuItem");
        }catch(NullPointerException e) {
            temp=stdPopUp.add(getActionByName("Cut"));
            temp.setName("Cut Popup MenuItem");
            temp=stdPopUp.add(getActionByName("Copy"));
            temp.setName("Copy Popup MenuItem");
            temp=stdPopUp.add(getActionByName("Paste"));
            temp.setName("Paste Popup MenuItem");
            stdPopUp.add(new JSeparator());
            temp=stdPopUp.add(getActionByName("Select All"));
            temp.setName("Select All Popup MenuItem");
        }
        stdPopUp.add(new JSeparator());
        temp=new JMenuItem("Do-It");
        temp.setActionCommand("Do-It");
        temp.setName("Do It Popup MenuItem");
        temp.addActionListener(this);
        stdPopUp.add(temp);
        
        temp=new JMenuItem("Print-It");
        temp.setActionCommand("Print-It");
        temp.setName("Print-It Popup MenuItem");
        temp.addActionListener(this);
        stdPopUp.add(temp);
        
        temp=new JMenuItem("Inspect-It");
        temp.setActionCommand("Inspect-It");
        temp.setName("Inspect It Popup MenuItem");
        temp.addActionListener(this);
        stdPopUp.add(temp);
        stdPopUp.addSeparator();
        
        temp=new JMenuItem("Compile");
        temp.setActionCommand("Compile");
        temp.setName("Compile JMenuItem JPopupMenu");
        temp.addActionListener(this);
        stdPopUp.add(temp);
        temp=new JMenuItem("Cancel");
        temp.setActionCommand("Cancel");
        temp.setName("Cancel JMenuItem JPopupMenu");
        temp.addActionListener(this);
        stdPopUp.add(temp);
        stdPopUp.addSeparator();
        
        temp=new JMenuItem("Set Break");
        temp.setActionCommand("Set Break");
        temp.setName("Set Break JMenuItem JPopupMenu");
        temp.addActionListener(this);
        stdPopUp.add(temp);
    }
    
    public void valueChanged(javax.swing.event.ListSelectionEvent listSelectionEvent) {
        Object comp=listSelectionEvent.getSource();
        
        if(comp==symbolDictionaries){
            if(symbolDictionaries.getModel().getSize()>0)
                dictionaryAction();
        }
        else if(comp==classes){
            if(classes.getModel().getSize()>0)
                classSelected();
        }
        else if(comp==protocol){
            if(protocol.getModel().getSize()>0)
                protocolAction();
        }
        else if(comp==methods)
            if(methods.getModel().getSize()>0)
                methodSelected();
        super.valueChanged(listSelectionEvent);
    }
    
    public void focusGained(java.awt.event.FocusEvent focusEvent) {
        Object comp=focusEvent.getSource();
        if(comp==this.symbolDictionaries)
            template=false;
        else
            if(comp==classes){
                if(classes.getModel().getSize()>0){
                    if(!template){
                        if(classes.getSelectedIndex()!=-1)
                            classSelected();
                        else{
                            classes.setSelectedIndex(0);
                            classSelected();
                        }}else template=false;
                }else
                    classes.transferFocus();
                
            }else  if(comp==protocol){
                if(protocol.getModel().getSize()>0){
                    if(protocol.getSelectedIndex()!=-1){
                        protocolAction();
                        template=false;
                    }
                    else{
                        protocol.setSelectedIndex(0);
                        protocolAction();
                        template=false;
                    }
                }else
                    protocol.transferFocus();
                
            }else  if(comp==methods){
                if(methods.getModel().getSize()>0){
                    if(!template){
                        if(methods.getSelectedIndex()!=-1)
                            methodSelected();
                        else{
                            methods.setSelectedIndex(0);
                            methodSelected();
                        }}else template=false;
                }else
                    methods.transferFocus();
                
            }
        super.focusGained(focusEvent);
    }
    
}
