

/*
 * GbjClassBrowser.java
 *
 * Created on May 23, 2002, 4:45 PM
 */

package com.gemstone.tools;

import com.gemstone.gbj.*;
import javax.swing.*;
import java.awt.Container;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Dimension;
import javax.swing.border.*;
import java.awt.*;
/**
 *
 * @author  vincef
 * @version 1.3
 */
public class GbjClassBrowser extends com.gemstone.tools.GbjBrowser {
    
    JTextField className;
    
    public GbjClassBrowser(GbjSession session, GbjLauncher launcher){
        this(session);
        this.launcher=launcher;
    }
    
    public GbjClassBrowser(GbjSession session){
        this();
        this.session=session;
        session_(session);
        initUI();
    }
    
    /** Creates new GbjClassBrowser */
    public GbjClassBrowser() {
        super();
    }
    
    protected void initUI() {
        setTitle("GBJ Class Browser");
        workspace=new JTextArea();
        createActionTable(workspace);
        makeActionPretty();
        initMenuBar();
        initPopupMenu();
        setJMenuBar(menuBar);
        setSize(400,300);
        content=this.getContentPane();
        content.setLayout(new BorderLayout());
        addWindowListener(this);
        //addComponentListener(this);
        methods=new JList();
        methods.addListSelectionListener(this);
        methods.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        classes=new JList();
        classes.addListSelectionListener(this);
        classes.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        protocol=new JList();
        protocol.addListSelectionListener(this);
        protocol.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        symbolDictionaries=new JList();
        sScroll=new JScrollPane(workspace);
        pScroll=new JScrollPane(protocol);
        pScroll.setViewportView(protocol);
        mScroll=new JScrollPane(methods);
        mScroll.setViewportView(methods);
        cScroll=new JScrollPane(classes);
        cScroll.setViewportView(classes);
        instOrClass=new ButtonGroup();
        instanceRB=new JRadioButton("Instance");
        classRB=new JRadioButton("Class");
        instOrClass.add(instanceRB);
        instOrClass.add(classRB);
        //listPanel=new JPanel();
        //listPanel.setLayout(new GridLayout(1,2));
        buttonPanel=new JPanel();
        buttonPanel.setLayout(new BorderLayout());
        JPanel p1=new JPanel(new GridBagLayout());
        GridBagConstraints constraint=new GridBagConstraints();
        constraint.fill=GridBagConstraints.HORIZONTAL;
        constraint.gridwidth=GridBagConstraints.RELATIVE;
        constraint.weightx=0;
        p1.add(instanceRB,constraint);
        constraint.gridwidth=GridBagConstraints.REMAINDER;
        p1.add(classRB,constraint);
        //p1.setMinimumSize(new Dimension(200,100));
        //p1.setPreferredSize(new Dimension(200,100));
        JPanel p2=new JPanel(new GridBagLayout());
        constraint.gridheight=GridBagConstraints.RELATIVE;
        constraint.weightx=1;
        cScroll.setAutoscrolls(false);
        p2.add(classes,constraint);
         constraint.gridheight=GridBagConstraints.REMAINDER;
        p2.add(p1,constraint);
        //buttonPanel.add(p1,BorderLayout.CENTER);
        //buttonPanel.add(cScroll,BorderLayout.NORTH);
        buttonPanel.add(p2,BorderLayout.NORTH);
        buttonPanel.add(pScroll,BorderLayout.CENTER);
        JSplitPane s1=new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,buttonPanel,mScroll);
        s1.setDividerSize(4);
        s1.setResizeWeight(.50);
        s1.setDividerLocation(.50);
        JSplitPane s2=new JSplitPane(JSplitPane.VERTICAL_SPLIT,s1,sScroll);
        s2.setDividerSize(4);
        s2.setResizeWeight(.25);
        s2.setDividerLocation(.25);
        //buttonPanel.setLayout(new GridBagLayout());
        //GridBagConstraints constraint=new GridBagConstraints();
        //constraint.fill=GridBagConstraints.BOTH;
        //constraint.weighty=0;
        //constraint.weightx=1;
        //constraint.gridwidth=GridBagConstraints.REMAINDER;
        //buttonPanel.add(cScroll,constraint);
        //constraint.gridwidth=GridBagConstraints.RELATIVE;
        //buttonPanel.add(instanceRB,constraint);
        //constraint.gridwidth=GridBagConstraints.REMAINDER;
        //buttonPanel.add(classRB,constraint);
        //constraint.weighty=1;
        //buttonPanel.add(pScroll,constraint);
        //content.add(sScroll,BorderLayout.CENTER);
        //content.add(listPanel,BorderLayout.NORTH);
        //listPanel.add(buttonPanel);
        //listPanel.add(mScroll);
        content.add(s2,BorderLayout.CENTER);
        if(mainFont!=null)updateFont(mainFont);
                updateTabSize(tabsize);
        updateWordWrap(wrap);
         FontMetrics tfont=getFontMetrics(classes.getFont());
        int fSize=(int)(tfont.getHeight()*1.5);
        cScroll.setPreferredSize(new Dimension(300,fSize));
        mScroll.setPreferredSize(new Dimension(300,4*fSize));
        pScroll.setPreferredSize(new Dimension(300,3*fSize));
        classes.addMouseListener(this);
        protocol.addMouseListener(this);
        methods.addMouseListener(this);
        workspace.addMouseListener(this);
        instanceRB.setActionCommand("Instance");
         classRB.setActionCommand("Class");
        instanceRB.setSelected(true);
        instanceRB.addActionListener(this);
        classRB.addActionListener(this);
        classes.setSelectedIndex(0);
        sScroll.setPreferredSize(new Dimension(600,8*fSize));
        initPopupMenu();
        initOtherPopups();
	// 27993: remove setNextFocusableComponent
        //classes.setNextFocusableComponent(protocol);
        classes.addFocusListener(this);
        //cScroll.setNextFocusableComponent(protocol);
        //protocol.setNextFocusableComponent(methods);
        //pScroll.setNextFocusableComponent(methods);
        //methods.setNextFocusableComponent(protocol);
        //mScroll.setNextFocusableComponent(protocol);
        methods.addFocusListener(this);
        protocol.addFocusListener(this);
        selectedComponent=workspace;
    }
    
    public void componentResized(java.awt.event.ComponentEvent componentEvent) {
        super.componentResized(componentEvent);
    }
    
    
    protected void addCustomMenus() {
        addClassMenu();
        addProtocolMenu();
        addMethodMenu();
    }
    
    String defaultTitle() {
        String className;
        
        if (this.selectedClass() == null) {
            className = classList[0].name();
        } else {
            className = this.selectedClass().name();
        }
        return("GBJ Class Browser: " + className);
    }
    
    void reinitialize() {
   /* Reinitialize the browser trying to maintain current selections and taking into
   account the browser type. */
        
        this.resetClass();
    }
    
    boolean acceptText(String newText) {
        return this.acceptClassOrMethodText(newText);
    }
    
    void postAcceptForClass_(GbxClassHolder aClass) {
        /* A class browser continues to view its class regardless of newly accepted classes. */
        
        this.resetClass();
    }
    
    void postMoveClass() {
        /* Class browsers should continue viewing the current class but update the view. */
        
        this.resetClass();
    }
    
    void postRemoveClass() {
        /* Class browsers should continue viewing the current class but update the view. */
        
        this.resetClass();
    }
    
    GbxDictionaryHolder selectedDictionaryForClass_(GbjObject aClass) {
        return this.dictionaryForClass_(aClass);
    }
    
    String text() {
        return this.textForClassOrMethod();
    }
    
    protected void displayWindow() {
        classes.setSelectedIndex(0);
        classSelected();
        launcher.registerWindow(this);
        setWindowID(launcher.getGlobalWindowID());
        setTitle(defaultTitle());
        launcher.addWindowMenu(this);
        super.displayWindow();
    }
    
}



