/*
 * GbjHierarchyBrowser.java
 *
 * Created on May 23, 2002, 4:49 PM
 */

package com.gemstone.tools;

import com.gemstone.gbj.*;
import javax.swing.*;
import java.awt.*;
/**
 *
 * @author  vincef
 * @version 1.3
 */
public class GbjHierarchyBrowser extends com.gemstone.tools.GbjBrowser {
    GbxClassHolder myClass;
    /** Creates new GbjHierarchyBrowser 
	@param aSession  GbjSession
	@param aLauncher GbjLauncher
    */
    public GbjHierarchyBrowser(GbjSession aSession, GbjLauncher aLauncher) {
        session=aSession;
        launcher=aLauncher;
        initUI();
    }
    protected void initUI() {
        setTitle("GBJ Class Browser");
        workspace=new JTextArea();
        createActionTable(workspace);
        makeActionPretty();
        initMenuBar();
        initPopupMenu();
        setJMenuBar(menuBar);
        setSize(400,300);
        content=this.getContentPane();
        content.setLayout(new BorderLayout());
        addWindowListener(this);
        //addComponentListener(this);
        methods=new JList();
        methods.addListSelectionListener(this);
        methods.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        classes=new JList();
        classes.addListSelectionListener(this);
        classes.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        protocol=new JList();
        protocol.addListSelectionListener(this);
        protocol.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        symbolDictionaries=new JList();
        sScroll=new JScrollPane(workspace);
        pScroll=new JScrollPane(protocol);
        pScroll.setViewportView(protocol);
        mScroll=new JScrollPane(methods);
        mScroll.setViewportView(methods);
        cScroll=new JScrollPane(classes);
        cScroll.setViewportView(classes);
        instOrClass=new ButtonGroup();
        instanceRB=new JRadioButton("Instance");
        classRB=new JRadioButton("Class");
        instOrClass.add(instanceRB);
        instOrClass.add(classRB);
        buttonPanel=new JPanel();
        buttonPanel.setLayout(new GridBagLayout());
        GridBagConstraints constraint=new GridBagConstraints();
        constraint.fill=GridBagConstraints.BOTH;
        constraint.weighty=1;
        constraint.weightx=1;
        constraint.gridwidth=GridBagConstraints.REMAINDER;
        buttonPanel.add(cScroll,constraint);
        constraint.weighty=0;
        constraint.gridwidth=GridBagConstraints.RELATIVE;
        buttonPanel.add(instanceRB,constraint);
        constraint.gridwidth=GridBagConstraints.REMAINDER;
        buttonPanel.add(classRB,constraint);
        JSplitPane s1=new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,buttonPanel,pScroll);
        s1.setDividerSize(4);
        s1.setDividerLocation(.50);
        s1.setResizeWeight(.50);
        JSplitPane s2=new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,s1,mScroll);
        s2.setDividerSize(4);
        s2.setDividerLocation(.50);
        s2.setResizeWeight(.66);
        JSplitPane s3=new JSplitPane(JSplitPane.VERTICAL_SPLIT,s2,sScroll);
        s3.setDividerSize(4);
        s3.setDividerLocation(.25);
        s3.setResizeWeight(.25);
        content.add(s3,BorderLayout.CENTER);
        /*listPanel=new JPanel();
        listPanel.setLayout(new GridLayout(1,3));
         
        content.add(sScroll,BorderLayout.CENTER);
        content.add(listPanel,BorderLayout.NORTH);
        listPanel.add(buttonPanel);
        listPanel.add(pScroll);
        listPanel.add(mScroll);*/
        if(mainFont!=null)updateFont(mainFont);
        updateTabSize(tabsize);
        updateWordWrap(wrap);
        FontMetrics tfont=getFontMetrics(classes.getFont());
        int fSize=(int)(tfont.getHeight()*4);
        cScroll.setPreferredSize(new Dimension(200,fSize));
        mScroll.setPreferredSize(new Dimension(200,2*fSize));
        pScroll.setPreferredSize(new Dimension(200,(int)(1.5*fSize)));
        classes.addMouseListener(this);
        protocol.addMouseListener(this);
        methods.addMouseListener(this);
        workspace.addMouseListener(this);
        instanceRB.setActionCommand("Instance");
        classRB.setActionCommand("Class");
        instanceRB.setSelected(true);
        instanceRB.addActionListener(this);
        classRB.addActionListener(this);
        classes.setSelectedIndex(0);
        sScroll.setPreferredSize(new Dimension(400,(int)(2.5*fSize)));
        initPopupMenu();
        initOtherPopups();
	// 27993: remove setNextFocusableComponent
        //classes.setNextFocusableComponent(protocol);
        classes.addFocusListener(this);
        //cScroll.setNextFocusableComponent(protocol);
        //protocol.setNextFocusableComponent(methods);
        //pScroll.setNextFocusableComponent(methods);
        //methods.setNextFocusableComponent(classes);
        //mScroll.setNextFocusableComponent(classes);
        methods.addFocusListener(this);
        protocol.addFocusListener(this);
        //symbolDictionaries.addFocusListener(this);
        selectedComponent=workspace;
    }
    
    
    
    void myClass_(GbxClassHolder aClass) {
        /* Set the target class of this hierarchy browser. */
        
        myClass = aClass;
    }
    
    GbxClassHolder myClass() {
        /* Return the target class of this hierarchy browser. */
        
        return myClass;
    }
    
    GbxClassHolder[] getClassList() {
        /* Return a list of class holders containing myClass's hierarchy. */
        
        return this.classHierarchyHoldersFor_(myClass.proxy());
    }
    
    void reinitialize() {
   /* Reinitialize the browser trying to maintain current selections and taking into
   account the browser type. */
        
        this.resetClassListSelecting_(this.selectedClass());
    }
    
    GbxDictionaryHolder selectedDictionaryForClass_(GbjObject aClass) {
        return this.dictionaryForClass_(aClass);
    }
    
    String text() {
        return this.textForClassOrMethod();
    }
    
    void postAcceptForClass_(GbxClassHolder aClass) {
        /* A hierarchy browser continues to view its class and associated hierarchy regardless of newly accepted classes. */
        
        this.resetClassListSelecting_(aClass);
    }
    
    boolean acceptText(String newText) {
        return this.acceptClassOrMethodText(newText);
    }
    
    void postRemoveClass() {
        /* Hierarchy browsers should continue viewing the current class but update the view. */
        
        this.resetClass();
    }
    
    void postMoveClass() {
        /* Hierarchy browsers should continue viewing the current class but update the view. */
        
        this.resetClass();
    }
    
    String defaultTitle() {
        return("GBJ Hierarchy Browser: " + this.myClass().name());
    }
    
    protected void displayWindow() {
        setWindowID(launcher.getGlobalWindowID());
        setTitle(defaultTitle());
        launcher.registerWindow(this);
        launcher.addWindowMenu(this);
        super.displayWindow();
    }
    
    protected void addCustomMenus() {
        addClassMenu();
        addProtocolMenu();
        addMethodMenu();
    }
}
