/*=========================================================================
 * Copyright (C) GemTalk Systems 1986-2024.  All Rights Reserved.
 *
 * Name: GbjIniFile.java
 *
 * Support for reading the contents of a GBJ initialization file.
 * Generates a HashMap dictionary of keys/values.
 *
 *========================================================================
 */

package com.gemstone.tools;

import com.gemstone.gbj.*; 
import com.gemstone.tools.*;
import java.io.*;
import java.util.*;

public class GbjIniFile {

    HashMap map;

    public GbjIniFile(String filename) 
	throws FileNotFoundException, IOException

    {
	BufferedReader in;
	String line;
	in = new BufferedReader(new FileReader(filename));
	map = new HashMap();
	while ((line = in.readLine()) != null) {
	    StringTokenizer st = new StringTokenizer(line, "= ");
	    if (st.hasMoreTokens()) {
		String key = st.nextToken();
		if (!key.equalsIgnoreCase(";")) {   // skip comment fields
		    if (st.hasMoreTokens()) {
			String value = st.nextToken();
			map.put(key,value);
		    }
		}
	    }
	}
    }

    public String get(String key) {
	return (String)map.get(key);
    }

    public Set keySet() {
	return map.keySet();
    }

}
