/*
 * GbjLoginDialog.java
 *
 * Created on May 6, 2002, 1:30 PM
 */

package com.gemstone.tools;

import javax.swing.*;
import javax.swing.border.*;
import java.awt.GridLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.FlowLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Insets;
import java.util.Properties;
import com.gemstone.gbj.GbjParameters;
import javax.swing.text.*;
import java.awt.event.KeyEvent;
// GBJ30: replace with java logging
//import com.gemstone.org.apache.log4j.*;
import java.util.logging.*;
/**
 *
 * GbjLoginDialog implements the login dialog window presented during login.
 * <p>
 * GBJ30: The following fields have been removed, since they have become
 * obsolete:
 * <ul>
 * <li> GemBroker Machine
 * <li> GemBroker Port
 * <li> Timeout
 * <li> Connect Timeout
 * </ul>
 *
 * @author <B>GemTalk Systems</B>
 * @version GBJ 1.3 Swing UI
 *
 */
public class GbjLoginDialog extends javax.swing.JDialog implements   
    java.awt.event.ComponentListener, java.awt.event.ActionListener {
    
    JLabel gemBrokerLabel;
    JTextField gemBrokerField;
    JLabel gemServerLabel;
    JTextField gemServerField;
    JLabel portBrokerLabel;
    JTextField portBrokerField;
    JLabel gUserLabel;
    JTextField gUserField;
    JLabel gPasswordLabel;
    JPasswordField gPasswordField;
    JLabel gemServiceLabel;
    JTextField gemServiceField;
    JLabel hUserLabel;
    JTextField hUserField;
    JLabel hPasswordLabel;
    JPasswordField hPasswordField;
    JLabel transactionLabel;
    JRadioButton manualTrans;
    JRadioButton autoTrans;
    JRadioButton format32;
    JRadioButton format641;
    JRadioButton format642;
    ButtonGroup transButtons;
    JLabel timeoutLabel;
    JTextField timeoutField;
    JLabel cTimeoutLabel;
    JTextField cTimeoutField;
    JButton okButton;
    JButton cancelButton;
    JPanel machinePanel;
    JPanel gUserPanel;
    JPanel sUserPanel;
    JPanel transactionPanel;
    JPanel buttonPanel;
    Container content;
    GbjParameters loginData;
    boolean dialogValue;
    java.util.Hashtable actions;
    Logger logger;

    // Constants for login dialog window sizing
    static private int BSIZE = 5;     // Border Size
    static private int EHEIGHT = 20;  // Entry height
    static private int EWIDTH  = 180; // Entry width (divisible by 2 and 3)
    static private int BTN_HEIGHT = 30; // Button height
    static private int BTN_WIDTH  = 80; // Button width
        
    /** Creates new GbjLoginDialog
     * @param sessionParameters Data used to create a GBJ session. Can be null.
     */
    public GbjLoginDialog(GbjParameters sessionParameters) {
        super();
        logger = Logger.getLogger("com.gemstone.tools");
        Action cutAction=new DefaultEditorKit.CutAction();
        Action copyAction=new DefaultEditorKit.CopyAction();
        Action pasteAction=new DefaultEditorKit.PasteAction();
        Keymap keymap;
        KeyStroke localkey;
        
        loginData=sessionParameters;
        dialogValue=false;
        setSize(250,300);
        setModal(true);
        setTitle("Gemstone Login");
        machinePanel=new JPanel();
	// GBJ30: gridlayout changed from 3,1 to 1,1
        machinePanel.setLayout(new GridLayout(1,1));
/* GBJ30
        Container hostBox=Box.createHorizontalBox();
        gemBrokerLabel=new JLabel("GemBroker Machine");
        gemBrokerLabel.setPreferredSize(new Dimension(EWIDTH,EHEIGHT));
        gemBrokerLabel.setBorder(new EmptyBorder(BSIZE,BSIZE,BSIZE,BSIZE));
        gemBrokerField=new JTextField();
        keymap=gemBrokerField.getKeymap();
        localkey =  KeyStroke.getKeyStroke( KeyEvent.VK_V,java.awt.Event.CTRL_MASK);
        keymap.addActionForKeyStroke(localkey,pasteAction);
        localkey =  KeyStroke.getKeyStroke( KeyEvent.VK_X,java.awt.Event.CTRL_MASK);
        keymap.addActionForKeyStroke(localkey,cutAction);
        localkey =  KeyStroke.getKeyStroke( KeyEvent.VK_C,java.awt.Event.CTRL_MASK);
        keymap.addActionForKeyStroke(localkey,copyAction);
        gemBrokerField.setName("Broker Host");
        gemBrokerField.setPreferredSize(new Dimension(EWIDTH,EHEIGHT));
        hostBox.add(gemBrokerLabel);
        hostBox.add(gemBrokerField);
        machinePanel.add(hostBox);
        
        Container portBox=Box.createHorizontalBox();
        portBrokerLabel=new JLabel("GemBroker Port");
        portBrokerLabel.setPreferredSize(new Dimension(EWIDTH,EHEIGHT));
        portBrokerField=new JTextField();
        portBrokerField.setName("Port");
        portBrokerField.setPreferredSize(new Dimension(EWIDTH,EHEIGHT));
        portBrokerLabel.setBorder(new EmptyBorder(BSIZE,BSIZE,BSIZE,BSIZE));
        portBox.add(portBrokerLabel);
        portBox.add(portBrokerField);
        machinePanel.add(portBox);
        keymap=portBrokerField.getKeymap();
        localkey =  KeyStroke.getKeyStroke( KeyEvent.VK_V,java.awt.Event.CTRL_MASK);
        keymap.addActionForKeyStroke(localkey,pasteAction);
        localkey =  KeyStroke.getKeyStroke( KeyEvent.VK_X,java.awt.Event.CTRL_MASK);
        keymap.addActionForKeyStroke(localkey,cutAction);
        localkey =  KeyStroke.getKeyStroke( KeyEvent.VK_C,java.awt.Event.CTRL_MASK);
        keymap.addActionForKeyStroke(localkey,copyAction);
*/
        
        Container serverBox=Box.createHorizontalBox();
        gemServerLabel=new JLabel("Gemstone Server");
        gemServerLabel.setPreferredSize(new Dimension(EWIDTH,EHEIGHT));
        gemServerField=new JTextField();
        gemServerField.setName("GemServer");
        gemServerField.setPreferredSize(new Dimension(EWIDTH,EHEIGHT));
        gemServerLabel.setBorder(new EmptyBorder(BSIZE,BSIZE,BSIZE,BSIZE));
        serverBox.add(gemServerLabel);
        serverBox.add(gemServerField);
        machinePanel.add(serverBox);
        machinePanel.setBorder(new EmptyBorder(BSIZE,BSIZE,BSIZE,BSIZE));
        keymap=gemServerField.getKeymap();
        localkey =  KeyStroke.getKeyStroke( KeyEvent.VK_V,java.awt.Event.CTRL_MASK);
        keymap.addActionForKeyStroke(localkey,pasteAction);
        localkey =  KeyStroke.getKeyStroke( KeyEvent.VK_X,java.awt.Event.CTRL_MASK);
        keymap.addActionForKeyStroke(localkey,cutAction);
        localkey =  KeyStroke.getKeyStroke( KeyEvent.VK_C,java.awt.Event.CTRL_MASK);
        keymap.addActionForKeyStroke(localkey,copyAction);
        
        Container gUserBox=Box.createHorizontalBox();
        gUserPanel=new JPanel();
        gUserPanel.setLayout(new GridLayout(2,1));
        gUserLabel=new JLabel("Gemstone User");
        gUserLabel.setPreferredSize(new Dimension(EWIDTH,EHEIGHT));
        gUserBox.add(gUserLabel);
        gUserLabel.setBorder(new EmptyBorder(BSIZE,BSIZE,BSIZE,BSIZE));
        gUserField=new JTextField();
        gUserField.setName("gusername");
        gUserField.setPreferredSize(new Dimension(EWIDTH,EHEIGHT));
        gUserBox.add(gUserField);
        keymap=gUserField.getKeymap();
        localkey =  KeyStroke.getKeyStroke( KeyEvent.VK_V,java.awt.Event.CTRL_MASK);
        keymap.addActionForKeyStroke(localkey,pasteAction);
        localkey =  KeyStroke.getKeyStroke( KeyEvent.VK_X,java.awt.Event.CTRL_MASK);
        keymap.addActionForKeyStroke(localkey,cutAction);
        localkey =  KeyStroke.getKeyStroke( KeyEvent.VK_C,java.awt.Event.CTRL_MASK);
        keymap.addActionForKeyStroke(localkey,copyAction);
        
        Container gPasswordBox=Box.createHorizontalBox();
        gPasswordLabel=new JLabel("Gemstone Password");
        gPasswordLabel.setBorder(new EmptyBorder(BSIZE,BSIZE,BSIZE,BSIZE));
        gPasswordLabel.setPreferredSize(new Dimension(EWIDTH,EHEIGHT));
        gPasswordField=new JPasswordField();
        gPasswordField.setName("gpassword");
        gPasswordField.setPreferredSize(new Dimension(EWIDTH,EHEIGHT));
        gPasswordBox.add(gPasswordLabel);
        gPasswordBox.add(gPasswordField);
        gUserPanel.add(gUserBox);
        gUserPanel.add(gPasswordBox);
        gUserPanel.setBorder(new EmptyBorder(BSIZE,BSIZE,BSIZE,BSIZE));
        keymap=gPasswordField.getKeymap();
        localkey =  KeyStroke.getKeyStroke( KeyEvent.VK_V,java.awt.Event.CTRL_MASK);
        keymap.addActionForKeyStroke(localkey,pasteAction);
        
        Container serviceBox=Box.createHorizontalBox();
        sUserPanel=new JPanel();
        sUserPanel.setLayout(new GridLayout(3,1));
        gemServiceLabel=new JLabel("Gem Service");
        gemServiceLabel.setPreferredSize(new Dimension(EWIDTH,EHEIGHT));
        gemServiceField=new JTextField();
        gemServiceField.setName("gService");
        gemServiceField.setPreferredSize(new Dimension(EWIDTH,EHEIGHT));
        gemServiceLabel.setBorder(new EmptyBorder(BSIZE,BSIZE,BSIZE,BSIZE));
        serviceBox.add(gemServiceLabel);
        serviceBox.add(gemServiceField);
        sUserPanel.add(serviceBox);
        keymap=gemServiceField.getKeymap();
        localkey =  KeyStroke.getKeyStroke( KeyEvent.VK_V,java.awt.Event.CTRL_MASK);
        keymap.addActionForKeyStroke(localkey,pasteAction);
        localkey =  KeyStroke.getKeyStroke( KeyEvent.VK_X,java.awt.Event.CTRL_MASK);
        keymap.addActionForKeyStroke(localkey,cutAction);
        localkey =  KeyStroke.getKeyStroke( KeyEvent.VK_C,java.awt.Event.CTRL_MASK);
        keymap.addActionForKeyStroke(localkey,copyAction);
        
        Container hUserBox=Box.createHorizontalBox();
        hUserLabel=new JLabel("Host User");
        hUserLabel.setPreferredSize(new Dimension(EWIDTH,EHEIGHT));
        hUserLabel.setBorder(new EmptyBorder(BSIZE,BSIZE,BSIZE,BSIZE));
        hUserField=new JTextField();
        hUserField.setName("huser");
        hUserField.setPreferredSize(new Dimension(EWIDTH,EHEIGHT));
        hUserBox.add(hUserLabel);
        hUserBox.add(hUserField);
        sUserPanel.add(hUserBox);
        keymap=hUserField.getKeymap();
        localkey =  KeyStroke.getKeyStroke( KeyEvent.VK_V,java.awt.Event.CTRL_MASK);
        keymap.addActionForKeyStroke(localkey,pasteAction);
        localkey =  KeyStroke.getKeyStroke( KeyEvent.VK_X,java.awt.Event.CTRL_MASK);
        keymap.addActionForKeyStroke(localkey,cutAction);
        localkey =  KeyStroke.getKeyStroke( KeyEvent.VK_C,java.awt.Event.CTRL_MASK);
        keymap.addActionForKeyStroke(localkey,copyAction);
        
        
        Container hPasswordBox=Box.createHorizontalBox();
        hPasswordLabel=new JLabel("Host Password");
        hPasswordLabel.setPreferredSize(new Dimension(EWIDTH,EHEIGHT));
        hPasswordField=new JPasswordField();
        hPasswordField.setName("hpassword");
        hPasswordField.setPreferredSize(new Dimension(EWIDTH,EHEIGHT));
        hPasswordLabel.setBorder(new EmptyBorder(BSIZE,BSIZE,BSIZE,BSIZE));
        hPasswordBox.add(hPasswordLabel);
        hPasswordBox.add(hPasswordField);
        sUserPanel.add(hPasswordBox);
        sUserPanel.setBorder(new EmptyBorder(BSIZE,BSIZE,BSIZE,BSIZE));
        keymap=hPasswordField.getKeymap();
        localkey =  KeyStroke.getKeyStroke( KeyEvent.VK_V,java.awt.Event.CTRL_MASK);
        keymap.addActionForKeyStroke(localkey,pasteAction);
        
        Container transactionBox=Box.createHorizontalBox();
        transactionPanel=new JPanel();
	// GBJ30: gridlayout changed from 3,1 to 1,1
        transactionPanel.setLayout(new GridLayout(1,1));
        transactionLabel=new JLabel("Transaction Mode");
        transactionLabel.setPreferredSize(new Dimension(EWIDTH,EHEIGHT));
        transactionLabel.setBorder(new EmptyBorder(BSIZE,BSIZE,BSIZE,BSIZE));
        manualTrans=new JRadioButton("Manual",true) ;
        manualTrans.setPreferredSize(new Dimension(EWIDTH/2,EHEIGHT));
        autoTrans=new JRadioButton("Auto") ;
        autoTrans.setPreferredSize(new Dimension(EWIDTH/2,EHEIGHT));
        manualTrans.setName("mtrans");
        autoTrans.setName("atrans");
        transactionBox.add(transactionLabel);
        JPanel radioPanel=new JPanel();
        radioPanel.setLayout(new GridLayout(1,2));
        radioPanel.setPreferredSize(new Dimension(EWIDTH,EHEIGHT));
        radioPanel.add(manualTrans);
        radioPanel.add(autoTrans);
        radioPanel.setBorder(new EmptyBorder(0,BSIZE*2,0,0));
        transactionBox.add(radioPanel);
        transButtons=new ButtonGroup();
        transButtons.add( manualTrans);
        transButtons.add( autoTrans);
        transactionPanel.add(transactionBox);
        transactionPanel.setBorder(new EmptyBorder(BSIZE,BSIZE,BSIZE,BSIZE));
/* GBJ30
        Container timeoutBox=Box.createHorizontalBox();
        timeoutLabel=new JLabel("TimeOut");
        timeoutLabel.setPreferredSize(new Dimension(EWIDTH,EHEIGHT));
        timeoutLabel.setBorder(new EmptyBorder(BSIZE,BSIZE,BSIZE,BSIZE));
        timeoutField=new JTextField();
        timeoutField.setName("timeout");
        timeoutField.setPreferredSize(new Dimension(EWIDTH,EHEIGHT));
        timeoutBox.add(timeoutLabel);
        timeoutBox.add(timeoutField);
        transactionPanel.add(timeoutBox);
        keymap=timeoutField.getKeymap();
        localkey =  KeyStroke.getKeyStroke( KeyEvent.VK_V,java.awt.Event.CTRL_MASK);
        keymap.addActionForKeyStroke(localkey,pasteAction);
        localkey =  KeyStroke.getKeyStroke( KeyEvent.VK_X,java.awt.Event.CTRL_MASK);
        keymap.addActionForKeyStroke(localkey,cutAction);
        localkey =  KeyStroke.getKeyStroke( KeyEvent.VK_C,java.awt.Event.CTRL_MASK);
        keymap.addActionForKeyStroke(localkey,copyAction);
        
        Container cTimeoutBox=Box.createHorizontalBox();
        cTimeoutLabel=new JLabel("Connect Timeout");
        cTimeoutLabel.setPreferredSize(new Dimension(EWIDTH,EHEIGHT));
        cTimeoutLabel.setBorder(new EmptyBorder(BSIZE,BSIZE,BSIZE,BSIZE));
        cTimeoutField=new JTextField();
        cTimeoutField.setName("connecttimeout");
        cTimeoutField.setPreferredSize(new Dimension(EWIDTH,EHEIGHT));
        cTimeoutBox.add(cTimeoutLabel);
        cTimeoutBox.add(cTimeoutField);
        transactionPanel.add(cTimeoutBox);
        keymap=cTimeoutField.getKeymap();
        localkey =  KeyStroke.getKeyStroke( KeyEvent.VK_V,java.awt.Event.CTRL_MASK);
        keymap.addActionForKeyStroke(localkey,pasteAction);
        localkey =  KeyStroke.getKeyStroke( KeyEvent.VK_X,java.awt.Event.CTRL_MASK);
        keymap.addActionForKeyStroke(localkey,cutAction);
        localkey =  KeyStroke.getKeyStroke( KeyEvent.VK_C,java.awt.Event.CTRL_MASK);
        keymap.addActionForKeyStroke(localkey,copyAction);

	Container formatBox=Box.createHorizontalBox();
	JPanel formatPanel=new JPanel();
	// formatPanel.setLayout(new GridLayout(3,1));
	JLabel formatLabel=new JLabel("GS Format");
	formatLabel.setPreferredSize(new Dimension(EWIDTH,EHEIGHT));
	formatLabel.setBorder(new EmptyBorder(BSIZE,BSIZE,BSIZE,BSIZE));
	format32=new JRadioButton("32", true);
	format32.setPreferredSize(new Dimension(EWIDTH/3,EHEIGHT));
	format32.setName("32");
	format641=new JRadioButton("64.1");
	format641.setPreferredSize(new Dimension(EWIDTH/3,EHEIGHT));
	format641.setName("64.1");
	format642=new JRadioButton("64.2");
	format642.setPreferredSize(new Dimension(EWIDTH/3,EHEIGHT));
	format642.setName("64.2");
	formatBox.add(formatLabel);
	JPanel fRadioPanel=new JPanel();
	fRadioPanel.setLayout(new GridLayout(1,3));
	fRadioPanel.setPreferredSize(new Dimension(EWIDTH,EHEIGHT));
	fRadioPanel.add(format32);
	fRadioPanel.add(format641);
	fRadioPanel.add(format642);
	fRadioPanel.setBorder(new EmptyBorder(0,BSIZE*2,0,0));
	formatBox.add(fRadioPanel);
	ButtonGroup formatButtons=new ButtonGroup();
	formatButtons.add(format32);
	formatButtons.add(format641);
	formatButtons.add(format642);
        formatPanel.add(formatBox);
        formatPanel.setBorder(new EmptyBorder(BSIZE,BSIZE,BSIZE,BSIZE));
*/
        
	buttonPanel=new JPanel();
        buttonPanel.setLayout(new GridBagLayout());
        GridBagConstraints constraint=new GridBagConstraints();
        constraint.insets=new Insets(BSIZE,BSIZE,BSIZE,BSIZE);
        okButton=new JButton("OK");
        okButton.setName("ok");
        cancelButton=new JButton("Cancel");
        cancelButton.setName("cancel");
        okButton.setPreferredSize(new Dimension(BTN_WIDTH,BTN_HEIGHT));
        cancelButton.setPreferredSize(new Dimension(BTN_WIDTH,BTN_HEIGHT));
        okButton.setActionCommand("Ok");
        cancelButton.setActionCommand("Cancel");
        buttonPanel.add(okButton,constraint);
        buttonPanel.add(cancelButton,constraint);
        okButton.addActionListener(this);
        cancelButton.addActionListener(this);
        JRootPane root=getRootPane();
        root.setDefaultButton(okButton);
        
        content=getContentPane();
        content.setLayout(new FlowLayout());
        Container dialogBox=Box.createVerticalBox();
        dialogBox.add(machinePanel);
        // dialogBox.add(new JSeparator());
        dialogBox.add(gUserPanel);
        dialogBox.add(new JSeparator());
        dialogBox.add(sUserPanel);
        dialogBox.add(new JSeparator());
        dialogBox.add(transactionPanel);
        dialogBox.add(new JSeparator());
	// dialogBox.add(formatPanel);
        dialogBox.add(new JSeparator());
        dialogBox.add(buttonPanel);
        content.add(dialogBox);
        addComponentListener(this);
        
        if(loginData==null) {
            //we shouldn't ever get this condition
            logger.severe("Invalid GbjParameters - can't be null");
        }
        else{
            
            //gemBrokerField.setText(loginData.brokerMachine);
            //portBrokerField.setText(Integer.toString(loginData.brokerPort));
            gemServerField.setText(loginData.serverName);
            //timeoutField.setText(Integer.toString(loginData.timeout));
            //cTimeoutField.setText(Integer.toString(loginData.connectTimeout));
            gUserField.setText(loginData.userName);
            hUserField.setText(loginData.serverOSUserName);
            gPasswordField.setText(loginData.password);
            hPasswordField.setText(loginData.serverOSPassword);
            gemServiceField.setText(loginData.gemnetName); // fix 40301
            if(loginData.transactionMode==GbjParameters.AutomaticTransactions) {
                autoTrans.setSelected(true);
            }
            else {
                manualTrans.setSelected(true);
            }
/* GBJ30
	    if(loginData.format==GbjParameters.FORMAT32)
		format32.setSelected(true);
	    else if (loginData.format==GbjParameters.FORMAT641)
		format641.setSelected(true);
	    else
		format642.setSelected(true);
*/
        }
        
        pack();
        Dimension windowSize=getSize();
        Dimension screen=java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        int x=(screen.width-windowSize.width)/2;
        int y=(screen.height-windowSize.height)/2;
        setLocation(x,y);
        setResizable(false);
        show();
    }
    
    
    
    public void componentShown(java.awt.event.ComponentEvent componentEvent) {
    }
    
    public void componentMoved(java.awt.event.ComponentEvent componentEvent) {
    }
    
    public void componentResized(java.awt.event.ComponentEvent componentEvent) {
        //setSize(325,350);
        //validate();
    }
    
    public void componentHidden(java.awt.event.ComponentEvent componentEvent) {
    }
    
    public void actionPerformed(java.awt.event.ActionEvent actionEvent) {
        if(actionEvent.getSource()==okButton) {
            
            if(loginData!=null){
                try{
/* GBJ30
                    if(gemBrokerField.getText().trim().length()==0)
                        loginData.brokerMachine=null;
                    else
                        loginData.brokerMachine=gemBrokerField.getText().trim();
                    
                    if(portBrokerField.getText().trim().length()==0)
                        loginData.brokerPort=-1;
                    else{
                        try{
                            loginData.brokerPort=Integer.parseInt(portBrokerField.getText().trim());
                        }catch(Exception e) {
                            loginData.brokerPort=-1;
                        }
                    }
*/
                    
                    if(gemServerField.getText().trim().length()==0) {
                        loginData.serverName=null;
                    }else{
                        loginData.serverName=gemServerField.getText().trim();
                    }
                    
		    loginData.serverName=gemServerField.getText().trim();

                    if(gemServiceField.getText().trim().length()==0) {
                        loginData.gemnetName="gemnetobject"; // 40301
                    }else{
                        loginData.gemnetName=gemServiceField.getText().trim();
                    }
                    
                    if(manualTrans.isSelected()){
                        loginData.transactionMode=GbjParameters.MANUAL_TRANSACTIONS;
                    }else if(autoTrans.isSelected()){
                        loginData.transactionMode=GbjParameters.AUTOMATIC_TRANSACTIONS;
                    }else{
                        loginData.transactionMode=GbjParameters.DEFAULT_TRANSACTION_MODE;
                    }

/* GBJ30
		    if (format32.isSelected()){
			loginData.format=GbjParameters.FORMAT32;
		    }else if (format641.isSelected()){
			loginData.format=GbjParameters.FORMAT641;
		    }else if (format642.isSelected()){
			loginData.format=GbjParameters.FORMAT642;
		    }else{
			loginData.format=GbjParameters.FORMAT32;
		    }
*/
                    
                    if (gUserField.getText().trim().length()==0)
                        loginData.userName=null;
                    else
                        loginData.userName=gUserField.getText().trim();
                    
                    if ((new String(gPasswordField.getPassword())).trim().length()==0)
                        loginData.password=null;
                    else
                        loginData.password=(new String(gPasswordField.getPassword())).trim();
                    
                    if ((new String(hPasswordField.getPassword())).trim().length()==0)
                        loginData.serverOSPassword=null;
                    else
                        loginData.serverOSPassword=(new String(hPasswordField.getPassword())).trim();
                    
                    if (hUserField.getText().trim().length()==0)
                        loginData.serverOSUserName=null;
                    else
                        loginData.serverOSUserName=hUserField.getText().trim();
/* GBJ30
                    try{
                        loginData.timeout=Integer.parseInt(timeoutField.getText().trim());
                    }catch(Exception ee){
                        loginData.timeout=GbjParameters.DEFAULT_TIMEOUT;
                    }
                    try{
                        loginData.connectTimeout=Integer.parseInt(cTimeoutField.getText().trim());
                    }catch(Exception eee){
                        loginData.connectTimeout=GbjParameters.DEFAULT_CONNECTION_TIMEOUT;
                    }
*/
                    dialogValue=true;
                    setVisible(false);
                }catch(NullPointerException ne) {
                    JOptionPane warning1=new JOptionPane("Error Invalid Login Parameters", JOptionPane.ERROR_MESSAGE);
                    JDialog dialog = warning1.createDialog(this, "Error");
                    logger.severe("Error Invalid Login Parameters");
                    logger.severe(ne.toString());
                    dialog.show();
                }
            }
            else {
                JOptionPane warning2=new JOptionPane("Error Invalid Login Parameters", JOptionPane.ERROR_MESSAGE);
                JDialog dialog = warning2.createDialog(this, "Error");
                 logger.severe("Error Invalid Login Parameters");
                dialog.show();
                dialogValue=false;
                setVisible(false);
            }
        }
        else
            if(actionEvent.getSource()==cancelButton) {
                dialogValue=false;
                this.setVisible(false);
            }
    }
    public boolean getDialogResult(){
        return dialogValue;
    }
    
 /*   public static class TestGbjLoginDialog extends junit.extensions.jfcunit.JFCTestCase {
        
        
        
        private class ModalThread extends Thread {
            public void run() {
                helper=new junit.extensions.jfcunit.JFCTestHelper();
                testDialog=new GbjLoginDialog(testParameters);
            }
        }
        
       
        private class ModalThread2 extends Thread {
            public void run() {
                helper2=new junit.extensions.jfcunit.JFCTestHelper();
                testDialog2=new GbjLoginDialog(testParameters2);
            }
        }
        
        private class ModalThread3 extends Thread {
            public void run() {
                helper3=new junit.extensions.jfcunit.JFCTestHelper();
                testDialog3=new GbjLoginDialog(testParameters2);
            }
        }
        
        private class ModalThread4 extends Thread {
            public void run() {
                helper4=new junit.extensions.jfcunit.JFCTestHelper();
                testDialog4=new GbjLoginDialog(testParameters2);
            }
        }
        
        
        GbjParameters testParameters;
        GbjParameters testParameters2;
        GbjParameters testParameters3;
        GbjParameters testParameters4;
        private junit.extensions.jfcunit.JFCTestHelper helper2;
        private junit.extensions.jfcunit.JFCTestHelper helper;
        private junit.extensions.jfcunit.JFCTestHelper helper3;
        private junit.extensions.jfcunit.JFCTestHelper helper4;
        GbjLoginDialog testDialog;
        GbjLoginDialog testDialog2;
        GbjLoginDialog testDialog3;
        GbjLoginDialog testDialog4;
        
        public  TestGbjLoginDialog(String name) {
            super(name);
            testParameters=null;
            testParameters2=new GbjParameters();
            Thread temp2=new ModalThread2();
            Thread temp3=new ModalThread3();
            Thread temp4=new ModalThread4();
            Thread temp=new ModalThread();
            temp3.start();
            temp4.start();
            temp2.start();
            temp.start();
            try{
                Thread.sleep(10000);//time for other thread with dialog to spin up
                awtSleep(1000);
            }catch(Exception e){}
        }
        
        
        public void testLoginDialogNull() {
            awtSleep();
            JDialog testDialog=null;
            java.util.List list=helper.getShowingDialogs("Gemstone Login");
            testDialog=(JDialog)list.get(0);
            JTextField testField=(JTextField)helper.findNamedComponent("Broker Host",testDialog,0);
            assertEquals(true,testField.getText().trim().equals("localhost"));
            JButton testButton=(JButton)helper.findComponent(JButton.class,testDialog,0);
            testButton.doClick();
            
            assertEquals(true,((GbjLoginDialog)testDialog).getDialogResult());
            awtSleep();
        }
        
        public void testLoginDialogGbjParameters(){
            awtSleep();
            
            awtSleep();
        }
        
        public void testLoginGbjParametersCancel(){
            awtSleep();
            
            awtSleep();
        }
        
        public static void main(String[] args) {
            junit.textui.TestRunner.run(suite());
            System.exit(0);
        }
        public static junit.framework.Test suite() {
            return new junit.framework.TestSuite(com.gemstone.tools.GbjLoginDialog.TestGbjLoginDialog.class);
        }
    }*/
    
}
