/*
 * GbjMethodBrowser.java
 *
 * Created on May 23, 2002, 5:03 PM
 */

package com.gemstone.tools;

import com.gemstone.gbj.*;
import javax.swing.*;
import java.awt.BorderLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Dimension;

/**
 *
 * @author  vincef
 * @version 1.3
 */
public class GbjMethodBrowser extends GbjBrowser {
    
    /** Creates new GbjMethodBrowser */
    String label;
    
    public GbjMethodBrowser(GbjSession session,GbjLauncher launcher) {
        this.session=session;
        this.launcher=launcher;
        initUI();
    }
    
    public GbjMethodBrowser(){
    }
    
    boolean isMethodBrowser() {
        return true;
    }
    void reinitialize() {
        this.resetMethod();
    }
    
    protected void initUI() {
       setTitle("GBJ Method Browser");
        workspace=new JTextArea();
        createActionTable(workspace);
        makeActionPretty();
        workspace.addMouseListener(this);
        sScroll=new JScrollPane(workspace);
        symbolDictionaries=new JList();
        classes=new JList();
        protocol=new JList();
        methods=new JList();
        mScroll=new JScrollPane();
        mScroll.setViewportView(methods);
        methods.addMouseListener(this);
        methods.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        initMenuBar();
        initPopupMenu();
        setJMenuBar(menuBar);
        content=this.getContentPane();
        content.setLayout(new BorderLayout());
        GridBagConstraints constraint=new GridBagConstraints();
        constraint.fill=GridBagConstraints.BOTH;
        constraint.gridwidth=GridBagConstraints.REMAINDER;
        content.add(methods,BorderLayout.NORTH);
        constraint.gridy=GridBagConstraints.RELATIVE;
        content.add(sScroll,BorderLayout.CENTER);
        addWindowListener(this);
        addComponentListener(this);
        initOtherPopups();  
       if(mainFont!=null)updateFont(mainFont);
                updateTabSize(tabsize);
        updateWordWrap(wrap);
        FontMetrics tfont=getFontMetrics(workspace.getFont());
        int fSize=(int)(tfont.getHeight()*1.5);
        mScroll.setPreferredSize(new Dimension(300,fSize));
       sScroll.setPreferredSize(new Dimension(300,300));
        ySize=getHeight();
        xSize=getWidth();
    }
    
    String text() {
        if (this.selectedMethod() == null) {
            return new String();
        } else {
            return this.textForMethod();
        }
    }
    
    protected void initCustomMenus() {
        methodMenu= new JMenu("Method");
        methodMenu.setName("Method Menu");
    }
    
    protected void addCustomMenus() {
        addMethodMenu();
    }
    
    boolean acceptText(String newText) {
        if (this.selectedMethod() == null) {
            return false;
        } else {
            return this.compileMethod(newText);
        }
    }
    
    protected void finishRemoveMethod() {
        try {
            this.serverSupport().removeMethod_fromClass_(this.selectedMethod().name(),  this.selectedClassOrMetaclass());
            this.methodList_method_(new GbxMethodHolder[0], null);
        } catch (GbjException e) {
            this.processError_(e);
        }
    }
    
    public void componentResized(java.awt.event.ComponentEvent componentEvent) {
        FontMetrics tfont=getFontMetrics(workspace.getFont());
        int fSize=(int)(tfont.getHeight()*1.5);
        int y=getHeight();
        int x=getWidth();
        sScroll.setPreferredSize(new Dimension(x,y-fSize));
        mScroll.setPreferredSize(new Dimension(x,fSize));
       sScroll.invalidate();
       mScroll.invalidate();
       validate();
       ySize=getHeight();
        xSize=getWidth();
    }
    
    public void updateFont(Font font) {
        workspace.setFont(font);
        methods.setFont(font);
    }
    
    protected void displayWindow() {
        methods.setSelectedIndex(0);
        update();
        super.displayWindow();
    }
    
}
