/*
 * GbjSplashScreen.java
 *
 * Created on January 2, 2003, 3:32 PM
 */

package com.gemstone.tools;

import java.util.*;
import javax.swing.*;
import java.awt.*;

/**
 *
 * @author  vincef
 */
public class GbjSplashScreen {
    
    static GbxSplashScreenManager manager;
    static LinkedList messages;
    static GbjSplashScreen splashscreen;
    
    private GbjSplashScreen() {
        messages=new LinkedList();
        manager=new GbxSplashScreenManager();
        (new Thread(manager)).start();
    }
    
    public static GbjSplashScreen getInstance(){
        if(splashscreen==null){
            splashscreen=new GbjSplashScreen();
            return splashscreen;
        }else return splashscreen;
    }
    
    public static synchronized void addActionMessage(java.lang.String message) {
        messages.addLast(message);
    }
    
    public static synchronized String getActionMessage(){
        if(messages.size()>0){
            return (String)messages.removeFirst();
        }
        else return null;
    }
    
    public static synchronized void initDone() {
        manager.done=true;
    }
    
    public static synchronized boolean done() {
     if(messages.size()>0) return false;
     else return true;
    }
}

class GbxSplashScreen extends javax.swing.JWindow{
    
    JTextArea textMessages;
    
    public GbxSplashScreen() {
        Dimension dim=Toolkit.getDefaultToolkit().getScreenSize();
        int x=(int)(dim.getWidth()-300)/2;
        int y=(int)(dim.getHeight()-300)/2;
        setCursor(new Cursor(Cursor.WAIT_CURSOR));
        Color color=new Color(160,78,195);
        GbxImagePanel sparkle=new GbxImagePanel();
        sparkle.setPreferredSize(new Dimension(100,50));
        sparkle.bytes(GbxGifs.logoBytes);
        //sparkle.setBackground(color);
        //sparkle.setForeground(color);
        textMessages =new JTextArea();
        textMessages.setBackground(color);
        textMessages.setEditable(false);
        textMessages.setCursor(new Cursor(Cursor.WAIT_CURSOR));
        JScrollPane spane=new JScrollPane(textMessages);
        Container con=getContentPane();
        con.setLayout(new BorderLayout());
        con.add(sparkle,BorderLayout.NORTH);
        con.add(spane,BorderLayout.CENTER);
        this.setBackground(color);
        this.setLocation(x,y);
        this.setSize(300,300);
    }
    
    public void displayMessage(java.lang.String message) {
        textMessages.append(message);
        int pos=textMessages.getDocument().getLength();
        textMessages.setCaretPosition(pos);
    }
}

class GbxSplashScreenManager implements java.lang.Runnable{
    boolean done=false;
    public void run() {
        GbxSplashScreen splash=new GbxSplashScreen();
        splash.show();
        String actionMessage=null;
        while(!done){
            actionMessage=GbjSplashScreen.getActionMessage();
            if(actionMessage!=null)splash.displayMessage(actionMessage+"\n");
            actionMessage=null;
            try{
               Thread.sleep(250);
            }catch(Exception e){}
        }
        actionMessage=GbjSplashScreen.getActionMessage();
        while(actionMessage!=null){
            splash.displayMessage(actionMessage+"\n");
            actionMessage=GbjSplashScreen.getActionMessage();
            try{
               Thread.sleep(250);
            }catch(Exception e){}
        }
        try{
            Thread.sleep(5000);
        }catch(Exception e){}
        splash.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        splash.dispose();
        splash=null;
    }
    
}

