/*=========================================================================
 * Copyright (C) GemTalk Systems 1986-2024.  All Rights Reserved.
 *
 * Name - GbxHolder.java
 *
 *========================================================================
 */

package com.gemstone.tools;

import com.gemstone.gbj.GbjObject;

class GbxHolder extends Object
{
	String name;
	GbjObject proxy;

GbxHolder()
{
	super();
}

GbxHolder(String aName, GbjObject aProxy)
{
	/* Create and return a holder with the given name and proxy. */

	this.name_(aName);
	this.proxy_(aProxy);
}

void proxy_(GbjObject aProxy)
{
	/* Set the proxy of the associated GemStone object. */

	proxy = aProxy;
}

GbjObject proxy()
{
	/* Return the proxy of the associated GemStone object. */

	return proxy;
}

String name()
{
	/* Return the name of the associated GemStone object. */

	return name;
}

void name_(String aName)
{
	/* Set the name of the associated GemStone object. */

	name = aName;
}

String displayString ()
{
	/* Return the default appearance of holders when viewed in
	GUI interfaces. */

	return this.name();
}

public String toString()
{
	return this.displayString();
}

}
