/*
 * GbxListDialog.java
 *
 * Created on July 12, 2002, 2:20 PM
 */

package com.gemstone.tools;

import javax.swing.*;
import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Dimension;
/**
 *
 * @author  vincef
 */
public class GbxListDialog extends javax.swing.JDialog implements java.awt.event.ActionListener{
    JLabel dataLabel;
    JScrollPane sList;
    JList datalist;
    JButton okButton;
    JButton cancelButton;
    boolean result;
    String dataItem;
    int selectedIndex;
    /** Creates a new instance of GbxListDialog 
	@param title String
	@param label String
	@param list String[]
    */
    public GbxListDialog(String title,String label,String[] list) {
        setTitle(title);
        setSize(250,300);
        setResizable(false);
        result=false;
        Container content=getContentPane();
        content.setLayout(new GridBagLayout());
        GridBagConstraints constraint=new GridBagConstraints();
        constraint.fill=GridBagConstraints.BOTH;
        constraint.weighty=1;
        constraint.gridwidth=GridBagConstraints.REMAINDER;
        dataLabel=new JLabel(label);
        content.add(dataLabel,constraint);
        datalist=new JList(list);
        datalist.setSelectedIndex(0);
        datalist.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        constraint.weightx=2;
        constraint.weighty=3;
        sList=new JScrollPane(datalist);   
        content.add(sList,constraint);
         constraint.fill=GridBagConstraints.NONE;
        constraint.weighty=1;
        constraint.gridwidth=GridBagConstraints.RELATIVE;
        okButton=new JButton("OK");
        
        cancelButton=new JButton("Cancel");
        okButton.addActionListener(this);
        cancelButton.addActionListener(this);
        content.add(okButton,constraint);
        constraint.gridwidth=GridBagConstraints.REMAINDER;
        content.add(cancelButton,constraint);
        setModal(true);
        JRootPane root=getRootPane();
        root.setDefaultButton(okButton);
        pack();
        Dimension windowSize=getSize();
        Dimension screen=java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        int x=(screen.width-windowSize.width)/2;
        int y=(screen.height-windowSize.height)/2;
        setLocation(x,y);
        setVisible(true);
    }
    
    public void actionPerformed(java.awt.event.ActionEvent actionEvent) { 
        if(actionEvent.getSource()==okButton){
            result=true;
            dataItem=(String)datalist.getSelectedValue();
            selectedIndex=datalist.getSelectedIndex();
            setVisible(false);
        }else{
            result=false;
            dataItem=null;
            selectedIndex=-1;
             setVisible(false);
        }
    }
    
    public String result(){
    if (result) return dataItem;
    else return null;
    }
    
    public int index(){
        return selectedIndex;
    }
}
