/*=========================================================================
 * Copyright (C) GemTalk Systems 1986-2024.  All Rights Reserved.
 *
 * Name - GbxObjectHolder.java
 *
 *========================================================================
 */

package com.gemstone.tools;

import com.gemstone.gbj.GbjObject;

class GbxObjectHolder extends GbxHolder {
    boolean isNamedSlot;
    int namedSlot;
    int indexableSlot;
    GbjObject slotObject;
    String className;
    int remoteSize;
    int fetchedSize;
    
    GbxObjectHolder(String aName, GbjObject aProxy) {
        super(aName, aProxy);
        isNamedSlot = true;
        namedSlot = -1;
        indexableSlot = -1;
        remoteSize = -1;
        fetchedSize = -1;
    }
    
    GbxObjectHolder(String aName, GbjObject aProxy, boolean aBoolean, int slot, GbjObject anObject, String aString) {
        super(aName, aProxy);
        isNamedSlot = aBoolean;
        if (isNamedSlot) {
            namedSlot = slot;
            indexableSlot = -1;
        } else {
            indexableSlot = slot;
            namedSlot = -1;
        }
        slotObject = anObject;
        className = aString;
        remoteSize = -1;
        fetchedSize = -1;
    }
    
}
