/*
 * GbxReportDialog.java
 *
 * Created on July 24, 2002, 10:34 AM
 */

package com.gemstone.tools;
import javax.swing.*;
import java.awt.*;
import com.gemstone.gbj.*;

/**
 *
 * @author  vincef
 */
public class GbxReportDialog extends javax.swing.JDialog implements java.awt.event.ActionListener{
    JButton reportButton;
    JButton okButton;
    JLabel report;
    String value="\nThe commit failed. \nUse the \"Report\" button to inspect transaction conflicts\n";
    GbjLauncher launcher;
    /** Creates a new instance of GbxReportDialog 
	@param launcher GbjLauncher
    */
    public GbxReportDialog(GbjLauncher launcher) {
        setModal(true);
        this.launcher=launcher;
        Container content=this.getContentPane();
        reportButton=new JButton("Report");
        reportButton.addActionListener(this);
        okButton=new JButton("Ok");
        okButton.addActionListener(this);
        report=new JLabel(value); 
        content.setLayout(new GridBagLayout());
        GridBagConstraints constraint=new GridBagConstraints();
        constraint.fill=GridBagConstraints.BOTH;
        constraint.gridwidth=GridBagConstraints.REMAINDER;
        content.add(report,constraint);
        constraint.gridwidth=GridBagConstraints.RELATIVE;
        constraint.weightx=1;
        content.add(okButton,constraint);
        constraint.gridwidth=GridBagConstraints.REMAINDER;
        content.add(reportButton,constraint);
        pack();
        Dimension windowSize=getSize();
        Dimension screen=java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        int x=(screen.width-windowSize.width)/2;
        int y=(screen.height-windowSize.height)/2;
        setLocation(x,y);
        setVisible(true);
    } 
    
    public void actionPerformed(java.awt.event.ActionEvent actionEvent) {
    if(actionEvent.getSource()==reportButton)
    {
        GbjObject conflicts=launcher.serverSupport().transactionConflicts();
        GbjInspector inspectit=new GbjInspector(conflicts,"Transaction Conflicts",launcher.session(),launcher);
        setModal(false);
        setVisible(false);
        dispose();
    }else if(actionEvent.getSource()==okButton)
    {
        setModal(false);
        setVisible(false);
        dispose();
    }
    }    
}
